<?php

/***** SUMMARY METRICS *****/

/* General Data Count 
   [IDEA_NUM, COMMENT_NUM, REVIEW_NUM, CONTEST_NUM] */
function idea_analytics_metric_data_count() {
	$all_reviews_stats = array();

	$all_reviews_stats['IDEA_NUM'] = 0;
	$all_reviews_stats['REVIEW_NUM'] = 0;
	$all_reviews_stats['CONTEST_NUM'] = 0;

	$result = db_query("SELECT COUNT(type) AS COUNT, type FROM node WHERE node.status=1 GROUP BY type");
	while ($data = db_fetch_object($result)) {
		if ($data->type=='idea')
		   	$all_reviews_stats['IDEA_NUM']=$data->COUNT;
		else if ($data->type=='review')
	   		$all_reviews_stats['REVIEW_NUM']=$data->COUNT;
		else if ($data->type=='contest')
		   	$all_reviews_stats['CONTEST_NUM']=$data->COUNT;
	}
		
	$result = db_query("SELECT COUNT(comments.cid) AS comment_count FROM comments JOIN node ON comments.nid=node.nid WHERE node.type='idea' AND node.status=1 AND comments.status=0");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['COMMENT_NUM']=$data->comment_count;
	}
	
	return $all_reviews_stats;
}

/* General Data Relations
   [IDEA_COM_AVG, IDEA_COM_MAX, IDEA_COM_MIN, IDEA_REV_AVG, IDEA_REV_MAX, IDEA_REV_MIN, IDEA_CONT_AVG, , IDEA_CONT_MAX, IDEA_CONT_MIN] */
function idea_analytics_metric_data_relations() {
	$all_reviews_stats = array();

	$result = db_query("SELECT MAX(IDEA_NUM) AS MAX_NUM, MIN(IDEA_NUM) AS MIN_NUM, AVG(IDEA_NUM) AS AVG_NUM FROM ( SELECT node.title, COUNT(comments.cid) AS IDEA_NUM FROM node LEFT JOIN comments ON (node.nid=comments.nid AND comments.status = 0) WHERE node.type='idea' AND node.status=1 GROUP BY node.nid ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['IDEA_COM_AVG']=$data->AVG_NUM;
	   	$all_reviews_stats['IDEA_COM_MAX']=$data->MAX_NUM;
	   	$all_reviews_stats['IDEA_COM_MIN']=$data->MIN_NUM;
	}
	
	$result = db_query("SELECT MAX(IDEA_NUM) AS MAX_NUM, MIN(IDEA_NUM) AS MIN_NUM, AVG(IDEA_NUM) AS AVG_NUM FROM ( SELECT node.nid, node.title, COUNT(content_field_review.field_review_nid) AS IDEA_NUM FROM node LEFT JOIN content_field_review ON (node.nid = content_field_review.nid) WHERE node.type = 'idea' AND node.status=1 GROUP BY node.nid ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['IDEA_REV_AVG']=$data->AVG_NUM;
	   	$all_reviews_stats['IDEA_REV_MAX']=$data->MAX_NUM;
	   	$all_reviews_stats['IDEA_REV_MIN']=$data->MIN_NUM;
	}
	
	$result = db_query("SELECT MAX(IDEA_NUM) AS MAX_NUM, MIN(IDEA_NUM) AS MIN_NUM, AVG(IDEA_NUM) AS AVG_NUM FROM ( SELECT content_type_idea.field_idea_contest_nid, COUNT(node.nid) AS IDEA_NUM  FROM node JOIN content_type_idea ON (node.nid = content_type_idea.nid AND content_type_idea.field_idea_contest_nid IS NOT NULL) WHERE node.type = 'idea' AND node.status=1 GROUP BY content_type_idea.field_idea_contest_nid ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['IDEA_CONT_AVG']=$data->AVG_NUM;
	   	$all_reviews_stats['IDEA_CONT_MAX']=$data->MAX_NUM;
	   	$all_reviews_stats['IDEA_CONT_MIN']=$data->MIN_NUM;
	}

	
	return $all_reviews_stats;
}


/* Users
   [USERS_NUM, UNIQ_USERS_IDEA_NUM, IDEA_USR_AVG, IDEA_USR_MAX, IDEA_USR_MIN, COM_USR_AVG, COM_USR_MAX, COM_USR_MIN] */
function idea_analytics_metric_users_summary() {

	$all_reviews_stats = array();

	$result = db_query("SELECT COUNT(name) AS COUNT FROM users WHERE name<>''");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['USERS_NUM']=$data->COUNT;
	}
	
	
	$result = db_query("SELECT COUNT(*) AS USER_COUNT FROM ( SELECT users.name FROM users JOIN node ON (node.uid=users.uid) WHERE users.name<>'' AND node.type='idea' AND node.status=1 GROUP BY users.name ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['UNIQ_USERS_IDEA_NUM']=$data->USER_COUNT;
	}
	
	$result = db_query("SELECT MAX(IDEA_NUM) AS MAX_NUM, MIN(IDEA_NUM) AS MIN_NUM, AVG(IDEA_NUM) AS AVG_NUM FROM ( SELECT users.name, COUNT(node.title) AS IDEA_NUM FROM users LEFT JOIN node ON (node.uid=users.uid AND node.type='idea' AND node.status=1) WHERE users.name<>'' GROUP BY users.name ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['IDEA_USR_AVG']=$data->AVG_NUM;
	   	$all_reviews_stats['IDEA_USR_MAX']=$data->MAX_NUM;
	   	$all_reviews_stats['IDEA_USR_MIN']=$data->MIN_NUM;
	}
	
	$result = db_query("SELECT MAX(COM_NUM) AS MAX_NUM, MIN(COM_NUM) AS MIN_NUM, AVG(COM_NUM) AS AVG_NUM FROM ( SELECT users.name, COUNT(comments.subject) AS COM_NUM FROM users LEFT JOIN comments ON (comments.uid=users.uid) WHERE users.name<>'' AND comments.status=0 GROUP BY users.name ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['COM_USR_AVG']=$data->AVG_NUM;
	   	$all_reviews_stats['COM_USR_MAX']=$data->MAX_NUM;
	   	$all_reviews_stats['COM_USR_MIN']=$data->MIN_NUM;
	}
		
	return $all_reviews_stats;

}

/* User Ranking
   [VOTE_IDEAS_TOTAL, RANK_IDEA_AVG, RANK_IDEA_MAX, RANK_IDEA_MIN, VOTE_IDEA_AVG, VOTE_IDEA_MAX, VOTE_IDEA_MIN, VOTEUP_IDEA_AVG, VOTEUP_IDEA_MAX, VOTEUP_IDEA_MIN
   ,VOTEDOWN_IDEA_AVG, VOTEDOWN_IDEA_MAX, VOTEDOWN_IDEA_MIN] */
function idea_analytics_metric_user_ranking() {

	$all_reviews_stats = array();
	
	//total votes for all ideas
	$result = db_query("SELECT COUNT(votingapi_vote.vote_id) AS total_votes FROM votingapi_vote JOIN node ON (votingapi_vote.content_id=node.nid AND votingapi_vote.content_type = 'node' AND node.type = 'idea' AND node.status=1) GROUP BY votingapi_vote.content_type");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['VOTE_IDEAS_TOTAL']=$data->total_votes;
	}
	
	//rating valute & total vote count
	$result = db_query("SELECT MAX(vote_sum) AS MAX_VOTESUM_NUM, MIN(vote_sum) AS MIN_VOTESUM_NUM, AVG(vote_sum) AS AVG_VOTESUM_NUM, MAX(total_votes) AS MAX_VOTECOUNT_NUM, MIN(total_votes) AS MIN_VOTECOUNT_NUM, AVG(total_votes) AS AVG_VOTECOUNT_NUM FROM ( SELECT SUM(COALESCE(votingapi_vote.value,0)) AS vote_sum, COUNT(votingapi_vote.value) AS total_votes, node.title FROM votingapi_vote RIGHT JOIN node ON (votingapi_vote.content_id=node.nid AND votingapi_vote.content_type = 'node') where node.type='idea' AND node.status=1 GROUP BY (node.nid) ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['RANK_IDEA_AVG']=$data->AVG_VOTESUM_NUM;
	   	$all_reviews_stats['RANK_IDEA_MAX']=$data->MAX_VOTESUM_NUM;
	   	$all_reviews_stats['RANK_IDEA_MIN']=$data->MIN_VOTESUM_NUM;
	   	
	   	$all_reviews_stats['VOTE_IDEA_AVG']=$data->AVG_VOTECOUNT_NUM;
	   	$all_reviews_stats['VOTE_IDEA_MAX']=$data->MAX_VOTECOUNT_NUM;
	   	$all_reviews_stats['VOTE_IDEA_MIN']=$data->MIN_VOTECOUNT_NUM;
	}
	//vote up count
	$result = db_query("SELECT MAX(votes_up) AS MAX_VOTEUP_NUM, MIN(votes_up) AS MIN_VOTEUP_NUM, AVG(votes_up) AS AVG_VOTEUP_NUM FROM ( SELECT COUNT(votingapi_vote.value) AS votes_up, node.title FROM votingapi_vote RIGHT JOIN node ON (votingapi_vote.content_id=node.nid AND votingapi_vote.content_type = 'node' AND votingapi_vote.value>0) where node.type='idea' AND node.status=1 GROUP BY (node.nid) ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['VOTEUP_IDEA_AVG']=$data->AVG_VOTEUP_NUM;
	   	$all_reviews_stats['VOTEUP_IDEA_MAX']=$data->MAX_VOTEUP_NUM;
	   	$all_reviews_stats['VOTEUP_IDEA_MIN']=$data->MIN_VOTEUP_NUM;
	}
	//vote down count
	$result = db_query("SELECT MAX(votes_down) AS MAX_VOTEDOWN_NUM, MIN(votes_down) AS MIN_VOTEDOWN_NUM, AVG(votes_down) AS AVG_VOTEDOWN_NUM FROM ( SELECT COUNT(votingapi_vote.value) AS votes_down, node.title FROM votingapi_vote RIGHT JOIN node ON (votingapi_vote.content_id=node.nid AND votingapi_vote.content_type = 'node' AND votingapi_vote.value<0) where node.type='idea' AND node.status=1 GROUP BY (node.nid) ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['VOTEDOWN_IDEA_AVG']=$data->AVG_VOTEDOWN_NUM;
	   	$all_reviews_stats['VOTEDOWN_IDEA_MAX']=$data->MAX_VOTEDOWN_NUM;
	   	$all_reviews_stats['VOTEDOWN_IDEA_MIN']=$data->MIN_VOTEDOWN_NUM;
	}
				
	return $all_reviews_stats;

}

/* Tags Summary
   [TAG_IDEA_AVG, TAG_IDEA_MAX, TAG_IDEA_MIN, IDEA_TAG_AVG, IDEA_TAG_MAX, IDEA_TAG_MIN, TOP_TAGS] */
function idea_analytics_metric_tag_summary() {

	$all_reviews_stats = array();
		
	//tags per idea
	$result = db_query("SELECT MAX(TAGS_COUNT) AS MAX_TAGS_NUM, MIN(TAGS_COUNT) AS MIN_TAGS_NUM, AVG(TAGS_COUNT) AS AVG_TAGS_NUM FROM ( SELECT node.nid, node.title, term_node.tid, COUNT(vocabulary.name) AS TAGS_COUNT FROM node LEFT JOIN term_node ON (node.nid= term_node.nid) LEFT JOIN term_data ON (term_node.tid = term_data.tid ) LEFT JOIN vocabulary ON (term_data.vid = vocabulary.vid AND vocabulary.name='Tags') WHERE node.type='idea' AND node.status=1 GROUP BY node.nid ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['TAG_IDEA_AVG']=$data->AVG_TAGS_NUM;
	   	$all_reviews_stats['TAG_IDEA_MAX']=$data->MAX_TAGS_NUM;
	   	$all_reviews_stats['TAG_IDEA_MIN']=$data->MIN_TAGS_NUM;
	}
	
	//ideas per tag
	$result = db_query("SELECT MAX(IDEA_COUNT) AS MAX_IDEAS_NUM, MIN(IDEA_COUNT) AS MIN_IDEAS_NUM, AVG(IDEA_COUNT) AS AVG_IDEAS_NUM FROM ( SELECT COUNT(node.nid) AS IDEA_COUNT, node.title, term_node.tid, vocabulary.name AS TAGS_COUNT FROM node LEFT JOIN term_node ON (node.nid= term_node.nid) LEFT JOIN term_data ON (term_node.tid = term_data.tid ) LEFT JOIN vocabulary ON (term_data.vid = vocabulary.vid) WHERE node.type='idea' AND node.status=1 AND vocabulary.name='Tags' GROUP BY tid ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['IDEA_TAG_AVG']=$data->AVG_IDEAS_NUM;
	   	$all_reviews_stats['IDEA_TAG_MAX']=$data->MAX_IDEAS_NUM;
	   	$all_reviews_stats['IDEA_TAG_MIN']=$data->MIN_IDEAS_NUM;
	}
	
	//top tags (most used)
	$result = db_query("SELECT COUNT(node.nid) AS IDEA_COUNT, node.title, term_node.tid, term_data.name, vocabulary.name AS TAGS_COUNT FROM node LEFT JOIN term_node ON (node.nid= term_node.nid) LEFT JOIN term_data ON (term_node.tid = term_data.tid ) LEFT JOIN vocabulary ON (term_data.vid = vocabulary.vid) WHERE node.type='idea' AND node.status=1 AND vocabulary.name='Tags' GROUP BY tid ORDER BY IDEA_COUNT DESC");

	$top_tag_count=-1;
	if ($data = db_fetch_object($result)) {
		$top_tag_count= $data->IDEA_COUNT;
		$all_reviews_stats['TOP_TAGS']= $data->name;
	}
	
	while ($data = db_fetch_object($result)) {		
		if ($data->IDEA_COUNT>=$top_tag_count)
			$all_reviews_stats['TOP_TAGS'].=', '.$data->name;
		else break;
	}

	return $all_reviews_stats;

}

/* Categories Summary
   [IDEA_CAT_AVG, IDEA_CAT_MAX, IDEA_CAT_MIN, TOP_CAT, BOTTOM_CAT] */
function idea_analytics_metric_category_summary() {

	$all_reviews_stats = array();
		
	//idea per category
	$result = db_query("SELECT MAX(ideas) AS MAX_IDEAS_NUM, MIN(ideas) AS MIN_IDEAS_NUM, AVG(ideas) AS AVG_IDEAS_NUM FROM ( SELECT term_data.tid, term_data.name, COUNT(term_node.nid) AS ideas from term_data JOIN vocabulary ON term_data.vid=vocabulary.vid LEFT JOIN term_node ON term_node.tid=term_data.tid LEFT JOIN node ON node.nid = term_node.nid WHERE vocabulary.name='Categories' AND ((node.type='idea' AND node.status=1) OR node.type IS NULL) GROUP BY (term_data.name) ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['IDEA_CAT_AVG']=$data->AVG_IDEAS_NUM;
	   	$all_reviews_stats['IDEA_CAT_MAX']=$data->MAX_IDEAS_NUM;
	   	$all_reviews_stats['IDEA_CAT_MIN']=$data->MIN_IDEAS_NUM;
	}
	
	//top category by ideas
	$result = db_query("SELECT term_data.tid, term_data.name, COUNT(term_node.nid) AS ideas from term_data JOIN vocabulary ON term_data.vid=vocabulary.vid LEFT JOIN term_node ON term_node.tid=term_data.tid LEFT JOIN node ON node.nid = term_node.nid WHERE vocabulary.name='Categories' AND ((node.type='idea' AND node.status=1) OR node.type IS NULL) GROUP BY (term_data.name) ORDER BY ideas DESC");

	$top_cat_count=-1;
	if ($data = db_fetch_object($result)) {
		$top_cat_count= $data->ideas;
		$all_reviews_stats['TOP_CAT']= $data->name;
	}
	
	while ($data = db_fetch_object($result)) {		
		if ($data->ideas>=$top_cat_count)
			$all_reviews_stats['TOP_CAT'].=', '.$data->name;
		else break;
	}
	
	//bottom category by ideas
	
	$result = db_query("SELECT term_data.tid, term_data.name, COUNT(term_node.nid) AS ideas from term_data JOIN vocabulary ON term_data.vid=vocabulary.vid LEFT JOIN term_node ON term_node.tid=term_data.tid LEFT JOIN node ON node.nid = term_node.nid WHERE vocabulary.name='Categories' AND ((node.type='idea' AND node.status=1) OR node.type IS NULL) GROUP BY (term_data.name) ORDER BY ideas ASC");

	$top_cat_count=-1;
	if ($data = db_fetch_object($result)) {
		$top_cat_count= $data->ideas;
		$all_reviews_stats['BOTTOM_CAT']= $data->name;
	}
	
	while ($data = db_fetch_object($result)) {		
		if ($data->ideas<=$top_cat_count)
			$all_reviews_stats['BOTTOM_CAT'].=', '.$data->name;
		else break;
	}
	
	return $all_reviews_stats;

}

/* Contest Summary
   [COM_CONT_AVG, COM_CONT_MAX, COM_CONT_MIN, TOP_CONT_IDEA, TOP_CONT_COM] */
function idea_analytics_metric_contest_summary() {

	$all_reviews_stats = array();
		
	//comments per contest
	$result = db_query("SELECT MAX(COM_NUM) AS MAX_COM_NUM, MIN(COM_NUM) AS MIN_COM_NUM, AVG(COM_NUM) AS AVG_COM_NUM FROM ( SELECT content_type_idea.field_idea_contest_nid, node.nid, COUNT(comments.cid) AS COM_NUM  FROM node LEFT JOIN comments ON (node.nid=comments.nid AND comments.status = 0) JOIN content_type_idea ON (node.nid = content_type_idea.nid AND content_type_idea.field_idea_contest_nid IS NOT NULL) WHERE node.type = 'idea' AND node.status=1 GROUP BY content_type_idea.field_idea_contest_nid ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['COM_CONT_AVG']=$data->AVG_COM_NUM;
	   	$all_reviews_stats['COM_CONT_MAX']=$data->MAX_COM_NUM;
	   	$all_reviews_stats['COM_CONT_MIN']=$data->MIN_COM_NUM;
	}
	
	//top contest by ideas
	$result = db_query("SELECT content_type_idea.field_idea_contest_nid, contests.title, COUNT(node.nid) AS IDEA_NUM  FROM node JOIN content_type_idea ON (node.nid = content_type_idea.nid AND content_type_idea.field_idea_contest_nid IS NOT NULL) JOIN node AS contests ON (contests.nid = content_type_idea.field_idea_contest_nid)  WHERE node.type = 'idea' AND node.status=1 GROUP BY content_type_idea.field_idea_contest_nid ORDER BY IDEA_NUM DESC");

	$top_com_count=-1;
	if ($data = db_fetch_object($result)) {
		$top_com_count= $data->IDEA_NUM;
		$all_reviews_stats['TOP_CONT_IDEA']= $data->title;
	}
	
	while ($data = db_fetch_object($result)) {		
		if ($data->IDEA_NUM>=$top_com_count)
			$all_reviews_stats['TOP_CONT_IDEA'].=', '.$data->title;
		else break;
	}
	
	//top contest by comments
	$result = db_query("SELECT content_type_idea.field_idea_contest_nid, contests.title, node.nid, COUNT(comments.cid) AS COM_NUM FROM node LEFT JOIN comments ON (node.nid=comments.nid AND comments.status = 0) JOIN content_type_idea ON (node.nid = content_type_idea.nid AND content_type_idea.field_idea_contest_nid IS NOT NULL) JOIN node AS contests ON (contests.nid = content_type_idea.field_idea_contest_nid) WHERE node.type = 'idea' AND node.status=1 GROUP BY content_type_idea.field_idea_contest_nid ORDER BY COM_NUM DESC");

	$top_com_count=-1;
	if ($data = db_fetch_object($result)) {
		$top_com_count= $data->COM_NUM;
		$all_reviews_stats['TOP_CONT_COM']= $data->title;
	}
	
	while ($data = db_fetch_object($result)) {		
		if ($data->COM_NUM>=$top_com_count)
			$all_reviews_stats['TOP_CONT_COM'].=', '.$data->title;
		else break;
	}

		
	return $all_reviews_stats;

}

/* Time Summary
   [TIME_FIRST_IDEA, TIME_LAST_IDEA, TIME_LAST_CONT, TIME_LAST_COMMENT] */
function idea_analytics_metric_time_summary() {

	$all_reviews_stats = array();
		
	//time since first idea posted
	$result = db_query("SELECT created, title FROM node WHERE type='idea' AND node.status=1 ORDER BY created ASC");
	if ($data = db_fetch_object($result)) {
		//$time = time() - $data->created;
		//date("D, j M Y \a\\t G:i", $created_date)
		$date1 = new DateTime("now"); 
		$date2 = new DateTime();
		$date2->setTimestamp($data->created);
		$interval = $date1->diff($date2);
	   	$all_reviews_stats['TIME_FIRST_IDEA']= $interval; //$interval->y . " years, " . $interval->m." months, ".$interval->d." days ".$interval->h . " hours, " . $interval->i." minutes, ".$interval->s." seconds ";
	}
	
	//time since last idea posted
	$result = db_query("SELECT created, title FROM node WHERE type='idea' AND node.status=1 ORDER BY created DESC");
	if ($data = db_fetch_object($result)) {
		//$time = time() - $data->created;
		//date("D, j M Y \a\\t G:i", $created_date)
		$date1 = new DateTime("now"); 
		$date2 = new DateTime();
		$date2->setTimestamp($data->created);
		$interval = $date1->diff($date2);
	   	$all_reviews_stats['TIME_LAST_IDEA']= $interval; //$interval->y . " years, " . $interval->m." months, ".$interval->d." days ";
	}
	
	//time since last idea contest created
	$result = db_query("SELECT created, title FROM node WHERE type='contest' AND node.status=1 ORDER BY created DESC");
	if ($data = db_fetch_object($result)) {
		//$time = time() - $data->created;
		//date("D, j M Y \a\\t G:i", $created_date)
		$date1 = new DateTime("now"); 
		$date2 = new DateTime();
		$date2->setTimestamp($data->created);
		$interval = $date1->diff($date2);
	   	$all_reviews_stats['TIME_LAST_CONT']= $interval; //$interval->y . " years, " . $interval->m." months, ".$interval->d." days ";
	}
	
	//time since last comment posted
	$result = db_query("SELECT timestamp, subject FROM comments WHERE comments.status = 0 ORDER BY timestamp DESC");
	if ($data = db_fetch_object($result)) {
		//$time = time() - $data->created;
		//date("D, j M Y \a\\t G:i", $created_date)
		$date1 = new DateTime("now"); 
		$date2 = new DateTime();
		$date2->setTimestamp($data->timestamp);
		$interval = $date1->diff($date2);
	   	$all_reviews_stats['TIME_LAST_COMMENT']= $interval; //$interval->y . " years, " . $interval->m." months, ".$interval->d." days ";
	}
		
	return $all_reviews_stats;

}

/* Characteristic Summary
   [CHAR_IDEA_AVG, CHAR_IDEA_MAX, CHAR_IDEA_MIN, TOP_CHAR, BOTTOM_CHAR, CHAR_IDEAS_COUNT, CHAR_IDEAS_PERCENT] */
function idea_analytics_metric_characteristic_summary() {

	$all_reviews_stats = array();
		
	//characteristics per idea
	$result = db_query("SELECT MAX(TERM_COUNT) AS MAX_TERM_COUNT, MIN(TERM_COUNT) AS MIN_TERM_COUNT, AVG(TERM_COUNT) AS AVG_TERM_COUNT FROM ( SELECT term_node.nid, COUNT(term_data.name) AS TERM_COUNT from term_node JOIN term_data ON term_node.tid = term_data.tid JOIN vocabulary ON vocabulary.vid = term_data.vid WHERE vocabulary.name = 'Idea Classification' GROUP BY term_node.nid ) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['CHAR_IDEA_AVG']=$data->AVG_TERM_COUNT;
	   	$all_reviews_stats['CHAR_IDEA_MAX']=$data->MAX_TERM_COUNT;
	   	$all_reviews_stats['CHAR_IDEA_MIN']=$data->MIN_TERM_COUNT;
	}
	
	//most / least used characteristics
	$result = db_query("SELECT COUNT(term_node.nid) AS TERM_COUNT, term_data.name AS TERM_NAME FROM term_node JOIN term_data ON term_node.tid = term_data.tid JOIN vocabulary ON vocabulary.vid = term_data.vid WHERE vocabulary.name = 'Idea Classification' GROUP BY term_data.name ORDER BY TERM_COUNT DESC;");

	$top_char_count=-1;
	if ($data = db_fetch_object($result)) {
		$top_char_count= $data->TERM_COUNT;
		$all_reviews_stats['TOP_CHAR']= $data->TERM_NAME;
	}
	
	while ($data = db_fetch_object($result)) {		
		if ($data->TERM_COUNT>=$top_char_count)
			$all_reviews_stats['TOP_CHAR'].=', '.$data->TERM_NAME;
		else break;
	}
	
	$result = db_query("SELECT COUNT(term_node.nid) AS TERM_COUNT, term_data.name AS TERM_NAME FROM term_node JOIN term_data ON term_node.tid = term_data.tid JOIN vocabulary ON vocabulary.vid = term_data.vid WHERE vocabulary.name = 'Idea Classification' GROUP BY term_data.name ORDER BY TERM_COUNT ASC;");

	$bottom_char_count=-1;
	if ($data = db_fetch_object($result)) {
		$bottom_char_count= $data->TERM_COUNT;
		$all_reviews_stats['BOTTOM_CHAR']= $data->TERM_NAME;
	}
	
	while ($data = db_fetch_object($result)) {		
		if ($data->TERM_COUNT<=$bottom_char_count)
			$all_reviews_stats['BOTTOM_CHAR'].=', '.$data->TERM_NAME;
		else break;
	}
	
	//ideas with characteristics
	$result = db_query("SELECT COUNT(VOCAB_NAME) AS CHAR_IDEA FROM (
SELECT node.nid AS NID_IDEA, term_data.name, vocabulary.name AS VOCAB_NAME FROM node LEFT JOIN term_node ON term_node.nid = node.nid LEFT JOIN term_data ON term_node.tid = term_data.tid LEFT JOIN vocabulary ON (vocabulary.vid = term_data.vid AND vocabulary.name = 'Idea Classification') WHERE node.type = 'idea' AND node.status=1 GROUP BY node.nid, vocabulary.name) AS SQ");

	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['CHAR_IDEAS_COUNT']=$data->CHAR_IDEA;
	} else $all_reviews_stats['CHAR_IDEAS_COUNT'] = 0;
	
	$result = db_query("SELECT COUNT(node.nid) AS ALL_IDEAS FROM node WHERE node.type = 'idea'");
	if ($data = db_fetch_object($result)) {
	   	if ($data->ALL_IDEAS==0)
	   		$all_reviews_stats['CHAR_IDEAS_PERCENT']=$data->ALL_IDEAS;
	   	else
	   		$all_reviews_stats['CHAR_IDEAS_PERCENT']=$all_reviews_stats['CHAR_IDEAS_COUNT']/$data->ALL_IDEAS*100;
	}

	return $all_reviews_stats;

}

/* Relationship Summary
   [REL_IDEA_AVG, REL_IDEA_MAX, REL_IDEA_MIN, TOP_REL, BOTTOM_REL, REL_IDEAS_COUNT, REL_IDEAS_PERCENT, REL_COUNT, REL_APPROVED_COUNT, REL_PENDING_COUNT, REL_APPROVED_PERCENT, REL_PENDING_PERCENT] */
function idea_analytics_metric_relationship_summary() {

	$all_reviews_stats = array();
		
	//relationships per idea
	$result = db_query("SELECT MAX(rel_count) AS MAX_REL_COUNT, MIN(rel_count) AS MIN_REL_COUNT, AVG(rel_count) AS AVG_REL_COUNT FROM (
SELECT node.nid, COUNT(similar_ideas_relations.relationship_type) AS rel_count FROM node LEFT JOIN similar_ideas_relations ON (node.nid = similar_ideas_relations.idea1 OR node.nid = similar_ideas_relations.idea2) AND similar_ideas_relations.relationship_type <> 'NONE' WHERE node.type='idea' AND node.status=1 AND similar_ideas_relations.status <> 'pending' GROUP BY node.nid) AS SQ");
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['REL_IDEA_AVG']=$data->AVG_REL_COUNT;
	   	$all_reviews_stats['REL_IDEA_MAX']=$data->MAX_REL_COUNT;
	   	$all_reviews_stats['REL_IDEA_MIN']=$data->MIN_REL_COUNT;
	}
	
	
	//most / least used characteristics
	$result = db_query("SELECT relationship_type AS REL_NAME, COUNT(relationship_type) AS REL_COUNT FROM similar_ideas_relations WHERE relationship_type <> 'NONE' AND similar_ideas_relations.status <> 'pending' GROUP BY relationship_type ORDER BY REL_COUNT DESC");

	$top_rel_count=-1;
	if ($data = db_fetch_object($result)) {
		$top_rel_count= $data->REL_COUNT;
		$all_reviews_stats['TOP_REL']= $data->REL_NAME;
	}
	
	while ($data = db_fetch_object($result)) {		
		if ($data->REL_COUNT>=$top_rel_count)
			$all_reviews_stats['TOP_REL'].=', '.$data->REL_NAME;
		else break;
	}
	
	$result = db_query("SELECT relationship_type AS REL_NAME, COUNT(relationship_type) AS REL_COUNT FROM similar_ideas_relations WHERE relationship_type <> 'NONE' AND similar_ideas_relations.status <> 'pending' GROUP BY relationship_type ORDER BY REL_COUNT ASC");

	$bottom_rel_count=-1;
	if ($data = db_fetch_object($result)) {
		$bottom_rel_count= $data->REL_COUNT;
		$all_reviews_stats['BOTTOM_REL']= $data->REL_NAME;
	}
	
	while ($data = db_fetch_object($result)) {		
		if ($data->REL_COUNT<=$bottom_rel_count)
			$all_reviews_stats['BOTTOM_REL'].=', '.$data->REL_NAME;
		else break;
	}
	
	$ideas_count = 0;
	//relationship count (all, approved, unapproved)
	$result = db_query("SELECT COUNT(DISTINCT node.nid) AS ALL_IDEA_COUNT, COUNT(similar_ideas_relations.relationship_type) AS ALL_REL_COUNT, COUNT(CASE WHEN similar_ideas_relations.status = 'approved' THEN 1 ELSE NULL END) AS APPROVED_COUNT, COUNT(CASE WHEN similar_ideas_relations.status = 'pending' THEN 1 ELSE NULL END) AS PENDING_COUNT FROM node LEFT JOIN similar_ideas_relations ON node.nid = similar_ideas_relations.idea1 AND similar_ideas_relations.relationship_type <> 'NONE' WHERE node.type='idea' AND node.status=1");

	if ($data = db_fetch_object($result)) {
		$ideas_count = $data->ALL_IDEA_COUNT;
	   	$all_reviews_stats['REL_COUNT']=$data->ALL_REL_COUNT;
	   	$all_reviews_stats['REL_APPROVED_COUNT']=$data->APPROVED_COUNT;
		$all_reviews_stats['REL_PENDING_COUNT']=$data->PENDING_COUNT;
	   	if ($data->ALL_REL_COUNT==0)
	   	{
	   		$all_reviews_stats['REL_APPROVED_PERCENT']=$data->ALL_REL_COUNT;
	   		$all_reviews_stats['REL_PENDING_PERCENT']=$data->ALL_REL_COUNT;
	   	}
	   	else
	   	{
	   		$all_reviews_stats['REL_APPROVED_PERCENT']=$data->APPROVED_COUNT/$data->ALL_REL_COUNT*100;
	   		$all_reviews_stats['REL_PENDING_PERCENT']=$data->PENDING_COUNT/$data->ALL_REL_COUNT*100;
	   	}
	}
	
	//ideas with relationships
	$result = db_query("SELECT COUNT(DISTINCT node.nid) AS ALL_IDEAS_REL FROM node JOIN similar_ideas_relations ON (node.nid = similar_ideas_relations.idea1 OR node.nid = similar_ideas_relations.idea2) AND similar_ideas_relations.relationship_type <> 'NONE' WHERE node.type='idea' AND node.status=1");

	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['REL_IDEAS_COUNT']=$data->ALL_IDEAS_REL;
	   	if ($ideas_count == 0)
	   		$all_reviews_stats['REL_IDEAS_PERCENT']=0;
	   	else
	   		$all_reviews_stats['REL_IDEAS_PERCENT']=$data->ALL_IDEAS_REL/$ideas_count*100;
	}

	return $all_reviews_stats;

}

/***************************************************/
/**** single metrics used in different places ******/
/***************************************************/

/* Number of Reviews */
function idea_analytics_metric_reviews_number() {

}

/* Number of Idea Contests */
function idea_analytics_metric_contests_number() {

}

/* Number of Ideas that have Idea Characteristics assigned */
/* @return [CHAR_IDEAS_COUNT, CHAR_IDEAS_PERCENT] */
function idea_analytics_metric_ideas_with_characteristics() {
	$all_reviews_stats= array();

	//ideas with characteristics
	$result = db_query("SELECT COUNT(VOCAB_NAME) AS CHAR_IDEA, COUNT(NID_IDEA) AS ALL_IDEAS FROM (
SELECT node.nid AS NID_IDEA, term_data.name, vocabulary.name AS VOCAB_NAME FROM node LEFT JOIN term_node ON term_node.nid = node.nid LEFT JOIN term_data ON term_node.tid = term_data.tid LEFT JOIN vocabulary ON (vocabulary.vid = term_data.vid AND vocabulary.name = 'Idea Classification') WHERE node.type = 'idea' AND node.status=1 GROUP BY node.nid
) AS SQ");

	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['CHAR_IDEAS_COUNT']=$data->CHAR_IDEA;
	   	if ($data->ALL_IDEAS==0)
	   		$all_reviews_stats['CHAR_IDEAS_PERCENT']=$data->ALL_IDEAS;
	   	else
	   		$all_reviews_stats['CHAR_IDEAS_PERCENT']=$data->CHAR_IDEA/$data->ALL_IDEAS*100;
	}
	
	return $all_reviews_stats;
}

/********************************************************/
/******* Idea relationships specific metrics **********/
/********************************************************/

/* Number of Idea Relationships in total in the IMS 
	[relationship_name] = relationship_count */
function idea_analytics_metric_relationship_count() {
	$idea_relationships = array();
	
	//$children = taxonomy_get_children(386,182);
	//$parents = taxonomy_get_parents_all(454);
	//$taxonomy = _taxonomy_get_path(182);
	//var_dump($taxonomy);
	//////////
	
	
	//get 'Idea Classification' vocabulary id
	$result = db_query("SELECT relationship_type AS REL_NAME, COUNT(relationship_type) AS REL_COUNT FROM similar_ideas_relations WHERE relationship_type <> 'NONE' AND similar_ideas_relations.status <> 'pending' GROUP BY relationship_type ORDER BY REL_NAME ASC");
	while ($data = db_fetch_object($result)) {
	   $idea_relationships[$data->REL_NAME]=$data->REL_COUNT;
	}
		
	return $idea_relationships;
}

/********************************************************/
/******* Idea characteristics specific metrics **********/
/********************************************************/

/* Number of Idea Characteristics in total in the IMS 
	[TRIGGER_COUNT, INNNOVATION_COUNT, PROPOSAL_COUNT, OBJECT_COUNT] */
function idea_analytics_metric_characteristic_count() {
	$idea_characteristics = array();
	
	//$children = taxonomy_get_children(386,182);
	//$parents = taxonomy_get_parents_all(454);
	//$taxonomy = _taxonomy_get_path(182);
	//var_dump($taxonomy);
	//////////
	
	
	//get 'Idea Classification' vocabulary id
	$result = db_query("SELECT vocabulary.vid FROM vocabulary WHERE vocabulary.name = 'Idea Classification'");
	if ($data = db_fetch_object($result)) {
	   $vocabulary_id=$data->vid;
	}
	
	if (isset($vocabulary_id)) { //if idea classification vocabulary exists
		//get annotations and their count
  		$result = db_query("SELECT COUNT(term_node.nid) AS TERM_COUNT, term_data.name AS TERM_NAME, term_data.tid AS TERM_TID, vocabulary.name AS VOCAB_NAME from term_node JOIN term_data ON term_node.tid=term_data.tid JOIN vocabulary ON vocabulary.vid=term_data.vid where vocabulary.name='Idea Classification' GROUP BY term_data.name");
  		$i=0;
  		
  		$result_array=idea_analytics_taxonomy_get_real_tree($vocabulary_id);
  		$tax_tree= $result_array[0]; //sorted taxonomy tree by root term
  		$tax_tree_unsorted= $result_array[1]; //unsorted tree
  		$tax_tid_to_id= $result_array[2]; //tables that translated tid into id in the unsorted taxonomy tree array
		$path_to_term = idea_analytics_taxonomy_get_path($tax_tree_unsorted,$tax_tid_to_id);
		$ordered_term_list = array();
		$innovation_term_list = array();
		$object_term_list = array();
		$trigger_term_list = array();
		$proposal_term_list = array();
		while ($data = db_fetch_object($result)) {
			if ($tax_tree[$data->TERM_TID]=='Innovation')
				array_push($innovation_term_list,$data);
			if ($tax_tree[$data->TERM_TID]=='Object')
				array_push($object_term_list,$data);
			if ($tax_tree[$data->TERM_TID]=='Trigger')
				array_push($trigger_term_list,$data);
			if ($tax_tree[$data->TERM_TID]=='ProposalType')
				array_push($proposal_term_list,$data);
		}
		$ordered_term_list = array_merge($trigger_term_list,$innovation_term_list,$proposal_term_list,$object_term_list);
		
		$idea_characteristics['TRIGGER_COUNT']=$trigger_term_list;
		$idea_characteristics['INNNOVATION_COUNT']=$innovation_term_list;
		$idea_characteristics['PROPOSAL_COUNT']=$proposal_term_list;
		$idea_characteristics['OBJECT_COUNT']=$object_term_list;
	}
	
	return $idea_characteristics;
}

/*********** Helper functions **********/

function idea_analytics_taxonomy_get_real_tree($vid){
  $innovation_ids = array();
  $object_ids = array();
  $trigger_ids = array();
  $proposal_ids = array();
  
  $tid_to_id = array(); // table that translated tids to ids in taxonomy_get_tree table
  $result_tree = array();
  $taxonomy_tree = taxonomy_get_tree($vid);
  $terms = array();
  $i=0;
  foreach($taxonomy_tree as $term){
  	$tid_to_id[$term->tid] = $i;
  	if ($term->name=='Innovation' || in_array($term->parents[0],$innovation_ids)) 
  		{ 
  			array_push($innovation_ids,$term->tid);
  			$result_tree[$term->tid]='Innovation';
  		}
  	if ($term->name=='Object' || in_array($term->parents[0],$object_ids)) 
  		{ 
  			array_push($object_ids,$term->tid);
  			$result_tree[$term->tid]='Object';
  		}
  	if ($term->name=='ProposalType' || in_array($term->parents[0],$proposal_ids)) 
  		{ 
  			array_push($proposal_ids,$term->tid);
  			$result_tree[$term->tid]='ProposalType';
  		}
  	if ($term->name=='Trigger' || in_array($term->parents[0],$trigger_ids)) 
  		{ 
  			array_push($trigger_ids,$term->tid);
  			$result_tree[$term->tid]='Trigger';
  		}
  	$i++;
  }
  //var_dump($tid_to_id);
  return array($result_tree, $taxonomy_tree, $tid_to_id);
} 

/* @param $taxonomy_tree array with taxonomy tree 
   @return array with tid as key and string with path to root as value (for every term)
*/
function idea_analytics_taxonomy_get_path($taxonomy_tree, $tid_to_id){
  
  $term_paths = array();
  $path = "";
  foreach($taxonomy_tree as $term){
  		$path = "";
  		if (isset($term->parents[0]))
  		{
  			$term2 = $taxonomy_tree[$tid_to_id[$term->parents[0]]];
  			if ($term2->name!='Innovation' && $term2->name!='Object' && $term2->name!='Trigger' && $term2->name!='ProposalType')
  				$path .= $term2->name;
  			while (isset($term2->parents[0])) {
  				$term2 = $taxonomy_tree[$tid_to_id[$term2->parents[0]]];
  				if ($term2->name!='Innovation' && $term2->name!='Object' && $term2->name!='Trigger' && $term2->name!='ProposalType')
  					$path = $term2->name . '/ ' . $path;
  			}
  		}
  		if (substr($path, 0, 1)=='/') $path = substr($path, 2);
  		if ($path==FALSE) $path="";
  		$term_paths[$term->tid] = $path;	
  }
  return $term_paths;
}

/********************************************************/
/***************** Idea specific metrics ****************/
/********************************************************/

/* Number of Ideas in time aggregated in days
	@return array[Date] = IDEA_COUNT */
function idea_analytics_metric_ideas_per_day($start_date, $end_date) {
	$idea_per_unit = array();
	
  	$result = db_query("SELECT COUNT(nid) AS IDEA_COUNT, node.created AS IDEA_DATE FROM node WHERE node.created > %d AND node.created < %d AND node.type= 'idea' AND node.status=1 GROUP BY DAY (FROM_UNIXTIME(node.created)) ORDER BY IDEA_DATE ASC",$start_date,$end_date);

	//init table with zeros for every day
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$idea_per_unit[date("Y-m-d", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 day");
	}

	while ($data = db_fetch_object($result))
		$idea_per_unit[date("Y-m-d", $data->IDEA_DATE)]=$data->IDEA_COUNT;

	return $idea_per_unit;
}

/* Number of Ideas in time aggregated in month
	@return array[Date] = IDEA_COUNT */
function idea_analytics_metric_ideas_per_month($start_date, $end_date) {
	$idea_per_unit = array();
	
  	$result = db_query("SELECT COUNT(nid) AS IDEA_COUNT, node.created AS IDEA_DATE FROM node WHERE node.created > %d AND node.created < %d AND node.type= 'idea' AND node.status=1 GROUP BY MONTH (FROM_UNIXTIME(node.created)) ORDER BY IDEA_DATE ASC",$start_date,$end_date);

	//init table with zeros for every day
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$idea_per_unit[date("Y-m", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 month");
	}

	while ($data = db_fetch_object($result))
		$idea_per_unit[date("Y-m", $data->IDEA_DATE)]=$data->IDEA_COUNT;

	return $idea_per_unit;
}

/* Number of Ideas per idea state in time aggregated in month
	@return array[state_name] = array[Date] = IDEA_COUNT */
function idea_analytics_metric_ideas_per_state_per_month($start_date, $end_date) {
	$idea_per_unit = array();
	$idea_per_state_per_unit = array();
		
	echo "start: ".$start_date;
	echo "end: ".$end_date;
  	$result = db_query("SELECT COUNT(node.nid) AS IDEA_COUNT, node.created AS IDEA_DATE , workflow_node.sid AS STATE_SID, workflow_states.state AS STATE_NAME FROM node JOIN workflow_node ON workflow_node.nid = node.nid JOIN workflow_states ON workflow_states.sid = workflow_node.sid WHERE node.created > %d AND node.created < %d AND node.type= 'idea' AND node.status = 1 GROUP BY workflow_node.sid, MONTH (FROM_UNIXTIME(node.created)) ORDER BY workflow_node.sid ASC, IDEA_DATE DESC",$start_date,$end_date);

	//init table with zeros for every day
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$idea_per_unit[date("Y-m", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 month");
	}

	
	$curr_state = -1;
	$curr_state_name = '';
	while ($data = db_fetch_object($result))
	{
		if ($curr_state != $data->STATE_SID) //if new state write the previous table into results array and start a new state array
		{
			if ($curr_state != -1) //dont write the init value into the results array
				$idea_per_state_per_unit[$curr_state_name] = $state_idea_per_unit; //save the idea state per unit array under state name
			$state_idea_per_unit = $idea_per_unit; //init new idea state table with zeros 
			$curr_state = $data->STATE_SID;
			$curr_state_name = $data->STATE_NAME;
		}
		
		$state_idea_per_unit[date("Y-m", $data->IDEA_DATE)]=$data->IDEA_COUNT;
		//$idea_per_unit[date("Y-m", $data->IDEA_DATE)]=$data->IDEA_COUNT;
	}
	$idea_per_state_per_unit[$curr_state_name] = $state_idea_per_unit; //add last interated state array 

	return $idea_per_state_per_unit;
}

/* Cummulative Number of Ideas per Idea State in time aggregated at the end of a month (in an entire year scale)
	@return array[state_name] = array[Date] = IDEA_COUNT */
function idea_analytics_metric_cumulative_ideas_per_state_per_month($start_date, $end_date) {
	$idea_per_unit = array();
	$idea_per_state_per_unit = array();
	//ignore day of start and always count since the start of the month
	$start_date = strtotime(date("Y-m", $start_date)); 
	//$end_date = strtotime(date("Y-m", $end_date));
	
	//init table with zeros for every month
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$idea_per_unit[date("Y-m", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 month");
	}

	$end_date_local=$start_date;
	for ($i = 1; $i<14; $i++) //query separately per each month
	{
		$end_date_local= strtotime(date("Y-m-d", $start_date) . " +".$i." month"); //increment month
		$start_date_local= strtotime(date("Y-m-d", $start_date) . " +".($i-1)." month"); //interval for the increment month
	
  		$result = db_query("SELECT COUNT(workflow_node_history.nid) AS IDEA_COUNT, workflow_node_history.stamp AS IDEA_DATE , workflow_node_history.sid AS STATE_SID, workflow_states.state AS STATE_NAME, CONCAT(MONTH (FROM_UNIXTIME(workflow_node_history.stamp)),'/',YEAR(FROM_UNIXTIME(workflow_node_history.stamp))) AS MONNTH_YEAR, SELF.MAX_DATE, node.status FROM workflow_node_history INNER JOIN 
(
SELECT workflow_node_history.nid, MAX(workflow_node_history.stamp) AS MAX_DATE FROM workflow_node_history WHERE workflow_node_history.stamp < %d GROUP BY workflow_node_history.nid
) SELF ON SELF.nid = workflow_node_history.nid AND SELF.MAX_DATE = workflow_node_history.stamp
JOIN workflow_states ON workflow_states.sid = workflow_node_history.sid
LEFT JOIN node ON workflow_node_history.nid = node.nid 
WHERE workflow_node_history.stamp < %d AND ((node.type= 'idea' AND node.status = 1) || node.status IS NULL) GROUP BY workflow_node_history.sid ORDER BY workflow_node_history.sid ASC",$end_date_local,$end_date_local);
	
		while ($data = db_fetch_object($result))
		{
			$curr_state_name = $data->STATE_NAME;
			if ($idea_per_state_per_unit[$curr_state_name] == NULL) //if new state, than zero the state table 
				$idea_per_state_per_unit[$curr_state_name] = $idea_per_unit;

			$idea_per_state_per_unit[$curr_state_name][date("Y-m", $start_date_local)] = $data->IDEA_COUNT;
		}

	}
	return $idea_per_state_per_unit;
}

/* Number of Ideas per idea status
	@return array with [IDEA_COUNT, STATE_SID, STATE_NAME] */
function idea_analytics_metric_ideas_per_status_count() {
	$idea_per_status = array();
	
  	$result = db_query("SELECT COUNT(node.nid) AS IDEA_COUNT , workflow_node.sid AS STATE_SID, workflow_states.state AS STATE_NAME FROM node JOIN workflow_node ON workflow_node.nid = node.nid JOIN workflow_states ON workflow_states.sid = workflow_node.sid WHERE node.type= 'idea' AND node.status = 1 GROUP BY workflow_node.sid ORDER BY workflow_node.sid ASC");

	while ($data = db_fetch_object($result))		
		array_push($idea_per_status, $data);

	return $idea_per_status;
}

/* Number of Ideas in Idea Contests 
	@return array with [CONTEST_TITLE, CONTEST_NID, IDEA_COUNT] */
function idea_analytics_metric_ideas_per_contest_count() {
	$idea_per_contest = array();
	
  	$result = db_query("SELECT COUNT(content_type_idea.nid) AS IDEA_COUNT, content_type_idea.field_idea_contest_nid AS CONTEST_NID, node.title AS CONTEST_TITLE FROM content_type_idea JOIN node ON content_type_idea.field_idea_contest_nid = node.nid WHERE field_idea_contest_nid IS NOT NULL GROUP BY content_type_idea.field_idea_contest_nid ORDER BY IDEA_COUNT DESC");

	while ($data = db_fetch_object($result))		
		array_push($idea_per_contest, $data);

	return $idea_per_contest;
}

/* Number of Ideas in Idea Categories 
	@return array with [CATEGORY_TITLE, CATEGORY_ID, IDEA_COUNT] */
function idea_analytics_metric_ideas_per_category_count() {
	$idea_per_category = array();
	
  	$result = db_query("SELECT term_data.tid AS CATEGORY_ID, term_data.name AS CATEGORY_TITLE, COUNT(term_node.nid) AS IDEA_COUNT from term_data JOIN vocabulary ON term_data.vid=vocabulary.vid LEFT JOIN term_node ON term_node.tid=term_data.tid LEFT JOIN node ON node.nid = term_node.nid WHERE vocabulary.name='Categories' AND ((node.type='idea' AND node.status=1) OR node.type IS NULL) GROUP BY (term_data.name) ORDER BY IDEA_COUNT DESC;");

	while ($data = db_fetch_object($result))		
		array_push($idea_per_category, $data);

	return $idea_per_category;
}

/*********************************************************/
/***************** Comment specific metrics **************/
/*********************************************************/

/* Number of Comment in time aggregated in days
	@return array[Date] = COMMENT_COUNT */
function idea_analytics_metric_comments_per_day($start_date, $end_date) {
	$comment_per_unit = array();
	
  	$result = db_query("SELECT COUNT(cid) AS COMMENT_COUNT, comments.timestamp AS COMMENT_DATE FROM comments WHERE comments.timestamp > %d AND comments.timestamp < %d GROUP BY DAY (FROM_UNIXTIME(comments.timestamp)) ORDER BY COMMENT_DATE ASC",$start_date,$end_date);

	//init table with zeros for every day
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$comment_per_unit[date("Y-m-d", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 day");
	}

	while ($data = db_fetch_object($result))
		$comment_per_unit[date("Y-m-d", $data->COMMENT_DATE)]=$data->COMMENT_COUNT;

	return $comment_per_unit;
}

/* Number of Comments in time aggregated in month
	@return array[Date] = COMMENT_COUNT */
function idea_analytics_metric_comments_per_month($start_date, $end_date) {
	$comment_per_unit = array();
	
  	$result = db_query("SELECT COUNT(cid) AS COMMENT_COUNT, comments.timestamp AS COMMENT_DATE FROM comments WHERE comments.timestamp > %d AND comments.timestamp < %d GROUP BY MONTH (FROM_UNIXTIME(comments.timestamp)) ORDER BY COMMENT_DATE ASC",$start_date,$end_date);

	//init table with zeros for every day
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$comment_per_unit[date("Y-m", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 month");
	}

	while ($data = db_fetch_object($result))
		$comment_per_unit[date("Y-m", $data->COMMENT_DATE)]=$data->COMMENT_COUNT;

	return $comment_per_unit;
}

/*********************************************************/
/***************** User specific metrics *****************/
/*********************************************************/

/* Number of Users registered in time aggregated in days
	@return array[Date] = USER_COUNT */
function idea_analytics_metric_users_per_day($start_date, $end_date) {
	$user_per_unit = array();
	
  	$result = db_query("SELECT COUNT(uid) AS USER_COUNT, users.created AS USER_DATE FROM users WHERE users.created > %d AND users.created < %d GROUP BY DAY (FROM_UNIXTIME(users.created)) ORDER BY USER_DATE ASC",$start_date,$end_date);

	//init table with zeros for every day
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$user_per_unit[date("Y-m-d", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 day");
	}

	while ($data = db_fetch_object($result))
		$user_per_unit[date("Y-m-d", $data->USER_DATE)]=$data->USER_COUNT;

	return $user_per_unit;
}

/* Number of Users registered in time aggregated in month
	@return array[Date] = USER_COUNT */
function idea_analytics_metric_users_per_month($start_date, $end_date) {
	$user_per_unit = array();
	
  	$result = db_query("SELECT COUNT(uid) AS USER_COUNT, users.created AS USER_DATE FROM users WHERE users.created > %d AND users.created < %d GROUP BY MONTH (FROM_UNIXTIME(users.created)) ORDER BY USER_DATE ASC",$start_date,$end_date);

	//init table with zeros for every day
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$user_per_unit[date("Y-m", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 month");
	}

	while ($data = db_fetch_object($result))
		$user_per_unit[date("Y-m", $data->USER_DATE)]=$data->USER_COUNT;

	return $user_per_unit;
}

/********************************************************/
/***************** Review specific metrics **************/
/********************************************************/

/* Number of Reviews in time aggregated in days
	@return array[Date] = REVIEW_COUNT */
function idea_analytics_metric_reviews_per_day($start_date, $end_date) {
	$review_per_unit = array();
	
  	$result = db_query("SELECT COUNT(nid) AS REVIEW_COUNT, node.created AS REVIEW_DATE FROM node WHERE node.created > %d AND node.created < %d AND node.type= 'review' AND node.status=1 GROUP BY DAY (FROM_UNIXTIME(node.created)) ORDER BY REVIEW_DATE ASC",$start_date,$end_date);

	//init table with zeros for every day
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$review_per_unit[date("Y-m-d", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 day");
	}

	while ($data = db_fetch_object($result))
		$review_per_unit[date("Y-m-d", $data->REVIEW_DATE)]=$data->REVIEW_COUNT;

	return $review_per_unit;
}

/* Number of Reviews in time aggregated in month
	@return array[Date] = REVIEW_COUNT */
function idea_analytics_metric_reviews_per_month($start_date, $end_date) {
	$review_per_unit = array();
	
  	$result = db_query("SELECT COUNT(nid) AS REVIEW_COUNT, node.created AS REVIEW_DATE FROM node WHERE node.created > %d AND node.created < %d AND node.type= 'review' AND node.status=1 GROUP BY MONTH (FROM_UNIXTIME(node.created)) ORDER BY REVIEW_DATE ASC",$start_date,$end_date);

	//init table with zeros for every day
	$currDate=$start_date;
	while ($currDate < $end_date)
	{
		$review_per_unit[date("Y-m", $currDate)]=0;
		$currDate = strtotime(date("Y-m-d", $currDate) . " +1 month");
	}

	while ($data = db_fetch_object($result))
		$review_per_unit[date("Y-m", $data->REVIEW_DATE)]=$data->REVIEW_COUNT;

	return $review_per_unit;
}


/* Number of Reviews in Review Categories 
	@return array with [CATEGORY_TITLE, CATEGORY_ID, REVIEW_COUNT] */
function idea_analytics_metric_reviews_per_category_count() {
	$review_per_category = array();
	
  	$result = db_query("SELECT term_data.tid AS CATEGORY_ID, term_data.name AS CATEGORY_TITLE, COUNT(term_node.nid) AS REVIEW_COUNT from term_data JOIN vocabulary ON term_data.vid=vocabulary.vid LEFT JOIN term_node ON term_node.tid=term_data.tid LEFT JOIN node ON node.nid = term_node.nid WHERE vocabulary.name='Review Types' AND ((node.type='review' AND node.status=1) OR node.type IS NULL) GROUP BY (term_data.name) ORDER BY REVIEW_COUNT DESC");

	while ($data = db_fetch_object($result))		
		array_push($review_per_category, $data);

	return $review_per_category;
}

?>