<?php

/***** DATA EXPORTS TO CSV (Comma Separated Values *****/

/*****************************************************************************
 ************************** IdeaStream Summary Tabs **************************
 *****************************************************************************/

function idea_analytics_summary_csv_export() {
	$general_data_count= idea_analytics_metric_data_count();
	$general_data_relations= idea_analytics_metric_data_relations();
	$users = idea_analytics_metric_users_summary();
	$user_ranking =idea_analytics_metric_user_ranking();
	$tags = idea_analytics_metric_tag_summary();
	$categories = idea_analytics_metric_category_summary();
	$contests = idea_analytics_metric_contest_summary();
	$statuses = idea_analytics_metric_ideas_per_status_count();
	$characteristics = idea_analytics_metric_characteristic_summary();
	if (module_exists('similar_ideas')) $relationships = idea_analytics_metric_relationship_summary();
	$time = idea_analytics_metric_time_summary();

	$similar_ideas_printed = FALSE; //used to check if similar ideas stats was already displayed or not
	
	$page_html="";

	$page_html .= 'Time Running'."\n";
	
	$page_html .= "Days since first idea posted,". ($time['TIME_FIRST_IDEA'] ? $time['TIME_FIRST_IDEA']->format('%a') : 'n/a' )."\n";
	
	$page_html .= "Days since last idea posted,". ($time['TIME_LAST_IDEA'] ? $time['TIME_LAST_IDEA']->format('%a') : 'n/a')."\n";
		
	$page_html .= "Days since last contest created,".($time['TIME_LAST_CONT'] ? $time['TIME_LAST_CONT']->format('%a') : 'n/a')."\n";
	
	$page_html .= "Days since last comment posted,".($time['TIME_LAST_COMMENT'] ? $time['TIME_LAST_COMMENT']->format('%a') : 'n/a')."\n";
	
//	$page_html .= "<div class='analytics_stats'><div class='analytics_stats_name'>Time since first idea posted</div> - <div class='analytics_time_metric_value'>".$time['TIME_LAST_IDEA']."</div></div>";

///	$page_html .= "<div class='analytics_stats'><div class='analytics_stats_name'>Time since first idea posted</div> - <div class='analytics_time_metric_value'>".$time['TIME_LAST_CONT']."</div></div>";
	
//	$page_html .= "<div class='analytics_stats'><div class='analytics_stats_name'>Time since first idea posted</div> - <div class='analytics_time_metric_value'>".$time['TIME_LAST_COMMENT']."</div></div>";
	
	// ************ GENERAL DATA COUNT & DATA RELATIONS
	$page_html .= 'General - Data Count'."\n";;
	
	$page_html .= "Number of Ideas,".$general_data_count['IDEA_NUM']."\n";;

	$page_html .= "Number of Comments,".$general_data_count['COMMENT_NUM']."\n";
	
	$page_html .= "Number of Reviews,".$general_data_count['REVIEW_NUM']."\n";
	
	$page_html .= "Number of Idea Contests,".$general_data_count['CONTEST_NUM']."\n";

	$page_html .= 'General - Data Relations'."\n";
	
	$page_html .= "Average Comments per Idea,".$general_data_relations['IDEA_COM_AVG']."\n";
	$page_html .= "Max Comments per Idea,".$general_data_relations['IDEA_COM_MAX']."\n";
	$page_html .= "Min Comments per Idea,".$general_data_relations['IDEA_COM_MIN']."\n";
	
	$page_html .= "Average Reviews per Idea,".$general_data_relations['IDEA_REV_AVG']."\n";
	$page_html .= "Max Reviews per Idea,".$general_data_relations['IDEA_REV_MAX']."\n";
	$page_html .= "Min Reviews per Idea,".$general_data_relations['IDEA_REV_MIN']."\n";
	
	$page_html .= "Average Ideas per Contest,".$general_data_relations['IDEA_CONT_AVG']."\n";
	$page_html .= "Max Ideas per Contest,".$general_data_relations['IDEA_CONT_MAX']."\n";
	$page_html .= "Min Ideas per Contest,".$general_data_relations['IDEA_CONT_MIN']."\n";
	
	// *********** USERS & USER VOTING
	$page_html .= 'Users'."\n";

	$page_html .= "Total Users,".$users['USERS_NUM']."\n";
	
	$page_html .= "Unique Users with Ideas,".$users['UNIQ_USERS_IDEA_NUM']."\n";
	
	$page_html .= "Average Ideas per User,".$users['IDEA_USR_AVG']."\n";
	$page_html .= "Max Ideas per User,".$users['IDEA_USR_MAX']."\n";
	$page_html .= "Min Ideas per User,".$users['IDEA_USR_MIN']."\n";
	
	$page_html .= "Average Comments per User,".$users['COM_USR_AVG']."\n";
	$page_html .= "Max Comments per User,".$users['COM_USR_MAX']."\n";
	$page_html .= "Min Comments per User,".$users['COM_USR_MIN']."\n";

	$page_html .= 'User Voting'."\n";
	
	$page_html .= "Total Votes Cast,".$user_ranking['VOTE_IDEAS_TOTAL']."\n";
	
	$page_html .= "Average Ranking per Idea,".substr($user_ranking['RANK_IDEA_AVG'],0,6)."\n";
	$page_html .= "Max Ranking per Idea,".$user_ranking['RANK_IDEA_MAX']."\n";
	$page_html .= "Min Ranking per Idea,".$user_ranking['RANK_IDEA_MIN']."\n";
	
	$page_html .= "Average Votes cast per Idea,".$user_ranking['VOTE_IDEA_AVG']."\n";
	$page_html .= "Max Votes cast per Idea,".$user_ranking['VOTE_IDEA_MAX']."\n";
	$page_html .= "Min Votes cast per Idea,".$user_ranking['VOTE_IDEA_MIN']."\n";
	
	$page_html .= "Average Votes cast up per Idea,".$user_ranking['VOTEUP_IDEA_AVG']."\n";
	$page_html .= "Max Votes cast up per Idea,".$user_ranking['VOTEUP_IDEA_MAX']."\n";
	$page_html .= "Min Votes cast up per Idea,".$user_ranking['VOTEUP_IDEA_MIN']."\n";
	
	$page_html .= "Average Votes cast down per Idea,".$user_ranking['VOTEDOWN_IDEA_AVG']."\n";
	$page_html .= "Max Votes cast down per Idea,".$user_ranking['VOTEDOWN_IDEA_MAX']."\n";
	$page_html .= "Min Votes cast down per Idea,".$user_ranking['VOTEDOWN_IDEA_MIN']."\n";
	
	// *********** TAGS & CATEGORIES
	$page_html .= 'Tags'."\n";;

	$page_html .= "Average Tags per Idea,".$tags['TAG_IDEA_AVG']."\n";
	$page_html .= "Max Tags per Idea,".$tags['TAG_IDEA_MAX']."\n";
	$page_html .= "Min Tags per Idea,".$tags['TAG_IDEA_MIN']."\n";
	
	$page_html .= "Average Ideas per Tag,".$tags['IDEA_TAG_AVG']."\n";
	$page_html .= "Max Ideas per Tag,".$tags['IDEA_TAG_MAX']."\n";
	$page_html .= "Min Ideas per Tag,".$tags['IDEA_TAG_MIN']."\n";
	
	$page_html .= "Most Used Tags,".$tags['TOP_TAGS']."\n";

	$page_html .= 'Categories'."\n";;
	
	$page_html .= "Average Ideas per Category".$categories['IDEA_CAT_AVG']."\n";
	$page_html .= "Max Ideas per Category".$categories['IDEA_CAT_MAX']."\n";
	$page_html .= "Min Ideas per Category".$categories['IDEA_CAT_MIN']."\n";
	
	$page_html .= "Most Used Categories,".$categories['TOP_CAT']."\n";
	
	$page_html .= "Least Used Categories,".$categories['BOTTOM_CAT']."\n";
	
	// *********** IDEA CONTESTS & IDEA STATUSES 
	$page_html .= 'Idea Contests'."\n";

	$page_html .= "Average Ideas per Contest,".$general_data_relations['IDEA_CONT_AVG']."\n";
	$page_html .= "Max Ideas per Contest,".$general_data_relations['IDEA_CONT_MAX']."\n";
	$page_html .= "Min Ideas per Contest,".$general_data_relations['IDEA_CONT_MIN']."\n";

	$page_html .= "Average Comments per Contest,".$contests['COM_CONT_AVG']. "\n";
	$page_html .= "Max Comments per Contest,".$contests['COM_CONT_MAX']. "\n";
	$page_html .= "Min Comments per Contest,".$contests['COM_CONT_MIN']. "\n";
	
	$page_html .= "Top Contest by Ideas,".$contests['TOP_CONT_IDEA']. "\n";
	
	$page_html .= "Top Contest by Comments,".$contests['TOP_CONT_COM']. "\n";
	
	$page_html .= 'Ideas Per Status'."\n";

	foreach ($statuses as $idea_state_stat)
		$page_html .= $idea_state_stat->STATE_NAME.",".$idea_state_stat->IDEA_COUNT."\n";
		
	/***** IDEAS PER IDEA CATEGORY ******/
	/**********************************************/
	$idea_contests_stats = idea_analytics_metric_ideas_per_category_count();
	
	$page_html .= "Ideas Per Category"."\n";
	
	foreach ($idea_contests_stats as $idea_contest_stat)
		$page_html .= $idea_contest_stat->CATEGORY_TITLE.",".$idea_contest_stat->IDEA_COUNT."\n";

	// *********** IDEA CHARACTERISTICS & IDEA SIMILARITY RELATIONSHIPS (optional)
	if (idea_analytics_gi2mo_types_access_check()) { //show characteristics summary only if gi2mo types has been installed
	$page_html .= 'Idea Characteristics'."\n";;
	
	$page_html .= "Average Characteristics per Idea,".($characteristics['CHAR_IDEA_AVG'] ? $characteristics['CHAR_IDEA_AVG'] : '-'). "\n";
	$page_html .= "Max Characteristics per Idea,".($characteristics['CHAR_IDEA_MAX'] ? $characteristics['CHAR_IDEA_MAX'] : '-'). "\n";
	$page_html .= "Min Characteristics per Idea,".($characteristics['CHAR_IDEA_MIN'] ? $characteristics['CHAR_IDEA_MIN'] : '-'). "\n";
	
	$page_html .= "Ideas Classified (count),". $characteristics['CHAR_IDEAS_COUNT'] . "\n";
	$page_html .= "Ideas Classified (percent),". round($characteristics['CHAR_IDEAS_PERCENT'],2) .'%'. "\n";
		
	$page_html .= "Most Used,".($characteristics['TOP_CHAR'] ? $characteristics['TOP_CHAR'] : 'n/a')."\n";
	
//	$page_html .= "<div class='analytics_stats'><div class='analytics_stats_name'>Least Used</div> - <div class='analytics_metric_value'>".$characteristics['BOTTOM_CHAR']."</div></div>";
	}
	if (module_exists('similar_ideas'))
	{
			$page_html .= 'Idea Relationships'."\n";
						
			$page_html .= "Relationship count,". $relationships['REL_COUNT'] ."\n";
			
			$page_html .= "Approved Relationships (count),". $relationships['REL_APPROVED_COUNT'] ."\n";
			$page_html .= "Approved Relationships (percent),". round($relationships['REL_APPROVED_PERCENT'],2) .'%'."\n";
			
			$page_html .= "Pending Relationships (count),". $relationships['REL_PENDING_COUNT'] ."\n";
			$page_html .= "Pending Relationships (precent),". round($relationships['REL_PENDING_PERCENT'],2) .'%'."\n";
			
			$page_html .= "Ideas with Relationships (count),". $relationships['REL_IDEAS_COUNT']."\n";
			$page_html .= "Ideas with Relationships (precent),".round($relationships['REL_IDEAS_PERCENT'],2) .'%'."\n";
			
			$page_html .= "Average Relationships per Idea,".$relationships['REL_IDEA_AVG']."\n";
			$page_html .= "Max Relationships per Idea,".$relationships['REL_IDEA_MAX']."\n";
			$page_html .= "Min Relationships per Idea,".$relationships['REL_IDEA_MIN']."\n";
				
			$page_html .= "Most Used,".$relationships['TOP_REL']."\n";	
	}
	
	return $page_html;

}

function idea_analytics_ideas_summary_csv_export() {
	$page_html = "";
	
	$todayDate = time();
	$dataPlusDay = strtotime(date("Y-m-d", time()) . " +1 day");
	$dataMinusMonth = strtotime(date("Y-m-d", time()) . " -1 month");
	$dateMinusYear = strtotime(date("Y-m-d", time()) . " -12 month");
	
	//$page_html .= "from: ".$dateMinusYear;
	
	/******* Number of Ideas in Month per Day ********/
	/*************************************************/
	
	$ideas_Month = idea_analytics_metric_ideas_per_day($dataMinusMonth,$todayDate);
	
	$page_html .= "Ideas Last Month (per Day)"."\n";
	foreach ($ideas_Month as $key => $value )
		$page_html .= $key.",".$value."\n";

	
	/******* Number of Ideas in Year per Month *******/
	/*************************************************/
	
	$comments_Month = idea_analytics_metric_ideas_per_month($dateMinusYear,$todayDate);
	
	$page_html .= "Ideas Last Year (per Month)"."\n";
	foreach ($comments_Month as $key => $value )
		$page_html .= $key.",".$value."\n";
		
	/******* Ideas per Status in Year per Month *******/
	/*************************************************/
	
	$idea_statuses_Month = idea_analytics_metric_cumulative_ideas_per_state_per_month($dateMinusYear,$todayDate);
	
	$page_html .= "Ideas per Status during Last Year (per Month)"; //."\n";
	$rows = array();
	foreach ($idea_statuses_Month as $status_name => $status_data )
	{
		$page_html .= ",".$status_name;//."\n";
		foreach ($status_data as $key => $value )
			if ($rows[$key]!=null) $rows[$key]= $rows[$key] . "," . $value;
				else $rows[$key] = " ". $value;
	}
	$page_html .= "\n";
	foreach ($rows as $key => $value )
		$page_html .= $key.",".$value."\n";
		
	/***** Current Number of Ideas per Status ******/
	/**********************************************/
	$idea_statuses_current = idea_analytics_metric_ideas_per_status_count();
	
	$page_html .= "Current Number of Ideas per Status"."\n";
	
	foreach ($idea_statuses_current as $idea_state_stat)
		$page_html .= $idea_state_stat->STATE_NAME.",".$idea_state_stat->IDEA_COUNT."\n";
		
	/***** Current Number of Ideas per Idea Category ******/
	/**********************************************/
	$idea_contests_stats = idea_analytics_metric_ideas_per_category_count();
	
	$page_html .= "Current Number of Ideas per Category"."\n";
	
	foreach ($idea_contests_stats as $idea_contest_stat)
		$page_html .= $idea_contest_stat->CATEGORY_TITLE.",".$idea_contest_stat->IDEA_COUNT."\n";
		
	/***** Current Number of Ideas in Idea Contests ******/
	/*********************************************/
	$idea_contests_stats = idea_analytics_metric_ideas_per_contest_count();
	
	$page_html .= "Current Number of Ideas per Contest"."\n";
		
	foreach ($idea_contests_stats as $idea_contest_stat)
		$page_html .= $idea_contest_stat->CONTEST_TITLE.",".$idea_contest_stat->IDEA_COUNT."\n";
		
	return $page_html;
}

function idea_analytics_comments_summary_csv_export() {
	$page_html = "";
			
	$todayDate = time();
	$dataPlusDay = strtotime(date("Y-m-d", time()) . " +1 day");
	$dataMinusMonth = strtotime(date("Y-m-d", time()) . " -1 month");
	$dateMinusYear = strtotime(date("Y-m-d", time()) . " -12 month");
	
	//$page_html .= "from: ".$dateMinusYear;
	
	/******* Number of Comments in Month per Day ******/
	/**************************************************/
	
	$comments_Month = idea_analytics_metric_comments_per_day($dataMinusMonth,$todayDate);
	
	$page_html .= "Comments Last Month (per Day)"."\n";
	foreach ($comments_Month as $key => $value )
		$page_html .= $key.",".$value."\n";
	
	/******* Number of Comments in Year per Month *****/
	/**************************************************/
	
	$comments_Month = idea_analytics_metric_comments_per_month($dateMinusYear,$todayDate);
	
	$page_html .= "Comments Last Year (per Month)"."\n";
	foreach ($comments_Month as $key => $value )
		$page_html .= $key.",".$value."\n";
	
	return $page_html;
}

function idea_analytics_users_summary_csv_export() {
	$page_html = "";

	$todayDate = time();
	$dataPlusDay = strtotime(date("Y-m-d", time()) . " +1 day");
	$dataMinusMonth = strtotime(date("Y-m-d", time()) . " -1 month");
	$dateMinusYear = strtotime(date("Y-m-d", time()) . " -12 month");
	
	//$page_html .= "from: ".$dateMinusYear;
	
	/******* Number of Users in Month per Day ********/
	/*************************************************/
	
	$ideas_Month = idea_analytics_metric_users_per_day($dataMinusMonth,$todayDate);
	
	$page_html .= "Users Last Month (per Day)"."\n";
	foreach ($ideas_Month as $key => $value )
		$page_html .= $key.",".$value."\n";
	
	/******* Number of Users in Year per Month *******/
	/*************************************************/
	
	$comments_Month = idea_analytics_metric_users_per_month($dateMinusYear,$todayDate);
	
	$page_html .= "Users Last Year (per Month)"."\n";
	foreach ($comments_Month as $key => $value )
		$page_html .= $key.",".$value."\n";
	
	return $page_html;
}

function idea_analytics_reviews_summary_csv_export() {
	$page_html = "";

	$todayDate = time();
	$dataPlusDay = strtotime(date("Y-m-d", time()) . " +1 day");
	$dataMinusMonth = strtotime(date("Y-m-d", time()) . " -1 month");
	$dateMinusYear = strtotime(date("Y-m-d", time()) . " -12 month");
	
	//$page_html .= "from: ".$dateMinusYear;
	
	/***** Number of Reviews in Month per Day ********/
	/*************************************************/
	
	$ideas_Month = idea_analytics_metric_reviews_per_day($dataMinusMonth,$todayDate);
	
	$page_html .= "Reviews Last Month (per Day)"."\n";
	foreach ($ideas_Month as $key => $value )
		$page_html .= $key.",".$value."\n";
	
	/***** Number of Reviews in Year per Month *******/
	/*************************************************/
	
	$comments_Month = idea_analytics_metric_reviews_per_month($dateMinusYear,$todayDate);
	
	$page_html .= "Reviews Last Year (per Month)"."\n";
	foreach ($comments_Month as $key => $value )
		$page_html .= $key.",".$value."\n";
	
	/***** Number of Reviews per Review Category ******/
	/**************************************************/
	$idea_contests_stats = idea_analytics_metric_reviews_per_category_count();
	
	$page_html .= "Number of Reviews per Review Type"."\n";
	foreach ($idea_contests_stats as $idea_contest_stat)
		$page_html .= $idea_contest_stat->CATEGORY_TITLE.",".$idea_contest_stat->REVIEW_COUNT."\n";
			
	return $page_html;
}

function idea_analytics_characteristics_summary_csv_export() {
	$page_html = "";
	
	//bar chart with number of annotations in total
	
	//get data from database
	$idea_characteristics=idea_analytics_metric_characteristic_count();
	$ideas_annotated_count = idea_analytics_metric_ideas_with_characteristics();
	
	$total_characteristics_count = count($idea_characteristics['TRIGGER_COUNT']) + count($idea_characteristics['INNNOVATION_COUNT']) + count($idea_characteristics['PROPOSAL_COUNT']) + count($idea_characteristics['OBJECT_COUNT']);
	//$total_characteristics_count=10;
	
	if ($total_characteristics_count>0) {
		//format data in vectors for chart
		//data series & x labels
		$page_html .= "Number of Ideas with Characteristic"."\n";
		$characteristic_number=0;
		foreach ($idea_characteristics['TRIGGER_COUNT'] as $characteristic)
		{
			$page_html .= $characteristic->TERM_NAME.",".$characteristic->TERM_COUNT."\n";
			$characteristic_number++;
		}

		foreach ($idea_characteristics['INNNOVATION_COUNT'] as $characteristic)
		{
			$page_html .= $characteristic->TERM_NAME.",".$characteristic->TERM_COUNT."\n";
			$characteristic_number++;
		}

		foreach ($idea_characteristics['PROPOSAL_COUNT'] as $characteristic)
		{
			$page_html .= $characteristic->TERM_NAME.",".$characteristic->TERM_COUNT."\n";
			$characteristic_number++;
		}

		foreach ($idea_characteristics['OBJECT_COUNT'] as $characteristic)
		{
			$page_html .= $characteristic->TERM_NAME.",".$characteristic->TERM_COUNT."\n";
			$characteristic_number++;
		}
				
	  	//test metrics
	  	$metric_median= idea_analytics_characteristics_metrics_median();
	  	//print table with metric values
		$page_html .= 'Gi2MO Types Metrics'."\n";
		foreach ($metric_median as $metric_name => $metric_value)
			$page_html .= $metric_name.",".$metric_value[0]."\n";
	  	//var_dump($metric_median);
  	}
		
	return $page_html;

}

function idea_analytics_relationships_summary_csv_export() {
	$page_html = "";

	//bar chart with number of annotations in total
	
	//get data from database
	$idea_relationships=idea_analytics_metric_relationship_count();
	$max_rel_count = 0;
	//$ideas_annotated_count = idea_analytics_metric_ideas_with_characteristics();
	
	$total_relationships_count = count($idea_relationships);
	//$total_characteristics_count=10;
	$page_html .= 'Relationships Total,'.$total_relationships_count."\n";
	
	//format data in vectors for chart
	//data series & x labels
	$idea_relationships_lebel_vector=array_fill(0,$total_relationships_count,'');
	//$idea_relationships_vector=array_fill(0,$total_relationships_count,0);
	$relationships_number=0;
	$page_html .= 'Relationships per Relationship Type'."\n";
	foreach ($idea_relationships as $relationship_name => $relationship_count)
		$page_html .= $relationship_name.",".$relationship_count."\n";
		
	return $page_html;
}

/*****************************************************************************
 ************************ Ideas List Full Panel ******************************
 *****************************************************************************/
 
function idea_analytics_ideas_csv_export() {
	$page_html = "";
	
	$upload_flag = module_exists('upload');
	$image_flag = module_exists('image');
	$gallery_flag = module_exists('gallery_assist');

	$query = "SELECT node.nid, node.created, node.title, node.uid as USER_ID, users.name as USER_NAME, node_comment_statistics.comment_count AS COMMENT_COUNT, votingapi_cache_node_points_sum.value AS VOTE_VALUE, votingapi_cache_node_points_count.value AS VOTE_COUNT, COUNT(content_type_review.nid) AS REVIEW_COUNT FROM node 
LEFT JOIN node_comment_statistics node_comment_statistics ON node.nid = node_comment_statistics.nid
LEFT JOIN votingapi_cache votingapi_cache_node_points_sum ON node.nid = votingapi_cache_node_points_sum.content_id AND (votingapi_cache_node_points_sum.content_type = 'node' AND votingapi_cache_node_points_sum.value_type = 'points' AND votingapi_cache_node_points_sum.function = 'sum') 
LEFT JOIN content_type_review ON node.nid = content_type_review.field_reviewed_idea_nid
LEFT JOIN users ON node.uid = users.uid
LEFT JOIN votingapi_cache votingapi_cache_node_points_count ON node.nid = votingapi_cache_node_points_count.content_id AND (votingapi_cache_node_points_count.content_type = 'node' AND votingapi_cache_node_points_count.value_type = 'points' AND votingapi_cache_node_points_count.function = 'count') 
WHERE type='idea' AND node.status=1
GROUP BY node.nid
ORDER BY created DESC";

	if ($upload_flag) //if upload module is enabled also put number of file attachments
		$query = "SELECT ideas_stats.*, COUNT(upload.fid) AS FILE_COUNT FROM ( ". $query . " ) AS ideas_stats LEFT JOIN upload ON ideas_stats.nid = upload.nid GROUP BY ideas_stats.nid";
		
	if ($image_flag) //if image module is enabled also put number of images inserted
		$query = "SELECT idea_stats2.*, COUNT(image_attach.iid) AS IMAGE_COUNT FROM ( ". $query . " ) AS idea_stats2 LEFT JOIN image_attach ON idea_stats2.nid = image_attach.nid GROUP BY idea_stats2.nid";
		
	if ($gallery_flag) //if image module is enabled also put number of images inserted
		$query = "SELECT idea_stats3.*, COUNT(gallery_assist_item.pid) AS GALLERY_COuNT FROM ( ". $query . " ) AS idea_stats3 LEFT JOIN gallery_assist_item ON idea_stats3.nid = gallery_assist_item.nid GROUP BY idea_stats3.nid";		
		
	
	$relationships = db_query($query);

	//format_date($checkbox_values['#custom_date'], 'small')
	$page_html .= 'Idea ID,Creation Date,Idea title,User ID, User name,Comment Count, Vote value, Vote count, Review count'.($upload_flag ? ",Attachment Count" :"").($image_flag ? ",Image Count" :"").($gallery_flag ? ",Gallery Count" :"")."\n";
	while ($data = db_fetch_object($relationships))
		$page_html .= $data->nid.",".format_date($data->created, 'small').",".$data->title.",".$data->USER_ID.",".$data->USER_NAME.",".$data->COMMENT_COUNT.",".($data->VOTE_VALUE ? $data->VOTE_VALUE : "0").",".($data->VOTE_COUNT ? $data->VOTE_COUNT : "0").",".$data->REVIEW_COUNT.($upload_flag ? ",".$data->FILE_COUNT : "").($image_flag ? ",".$data->IMAGE_COUNT : "").($gallery_flag ? ",".$data->GALLERY_COuNT : "")."\n";
		
	return $page_html;
}

/*****************************************************************************
 ************************ Contest List Full Panel ******************************
 *****************************************************************************/
 
function idea_analytics_contests_csv_export() {
	$page_html = "";
	
	$upload_flag = module_exists('upload');
	$image_flag = module_exists('image');
	$gallery_flag = module_exists('gallery_assist');

	$query = "SELECT node.nid, node.title, node.created, workflow_states.state, node.uid as USER_ID, users.name as USER_NAME, COUNT(content_type_idea.nid) AS IDEA_COUNT FROM node 
LEFT JOIN workflow_node ON node.nid = workflow_node.nid 
LEFT JOIN workflow_states ON workflow_node.sid = workflow_states.sid
LEFT JOIN users ON node.uid = users.uid
LEFT JOIN content_type_idea ON node.nid = content_type_idea.field_idea_contest_nid WHERE node.type='contest' AND node.status=1 GROUP BY node.nid ORDER BY node.created DESC";

	if ($upload_flag) //if upload module is enabled also put number of file attachments
		$query = "SELECT ideas_stats.*, COUNT(upload.fid) AS FILE_COUNT FROM ( ". $query . " ) AS ideas_stats LEFT JOIN upload ON ideas_stats.nid = upload.nid GROUP BY ideas_stats.nid";
		
	if ($image_flag) //if image module is enabled also put number of images inserted
		$query = "SELECT idea_stats2.*, COUNT(image_attach.iid) AS IMAGE_COUNT FROM ( ". $query . " ) AS idea_stats2 LEFT JOIN image_attach ON idea_stats2.nid = image_attach.nid GROUP BY idea_stats2.nid";
		
	if ($gallery_flag) //if image module is enabled also put number of images inserted
		$query = "SELECT idea_stats3.*, COUNT(gallery_assist_item.pid) AS GALLERY_COuNT FROM ( ". $query . " ) AS idea_stats3 LEFT JOIN gallery_assist_item ON idea_stats3.nid = gallery_assist_item.nid GROUP BY idea_stats3.nid";		
		
	
	$relationships = db_query($query);

	//format_date($checkbox_values['#custom_date'], 'small')
	$page_html .= 'Contest ID,Creation Date,Contest title,Creator User ID, Creator User name,Idea Count'.($upload_flag ? ",Attachment Count" :"").($image_flag ? ",Image Count" :"").($gallery_flag ? ",Gallery Count" :"")."\n";
	while ($data = db_fetch_object($relationships))
		$page_html .= $data->nid.",".format_date($data->created, 'small').",".$data->title.",".$data->USER_ID.",".$data->USER_NAME.",".$data->IDEA_COUNT.($upload_flag ? ",".$data->FILE_COUNT : "").($image_flag ? ",".$data->IMAGE_COUNT : "").($gallery_flag ? ",".$data->GALLERY_COuNT : "")."\n";
		
	return $page_html;
}

/*****************************************************************************
 ************************ Reviews List Full Panel ******************************
 *****************************************************************************/
 
function idea_analytics_reviews_csv_export() {
	$page_html = "";
	
	$upload_flag = module_exists('upload');
	$image_flag = module_exists('image');
	$gallery_flag = module_exists('gallery_assist');

	$query = "SELECT node.nid, node.title, node.created, node.uid as USER_ID, users.name as USER_NAME, content_type_review.field_review_rating_value AS REVIEW_RATING, content_type_review.field_reviewed_idea_nid AS IDEA_NID, term_data.name AS REVIEW_TYPE FROM node 
LEFT JOIN users ON node.uid = users.uid
LEFT JOIN content_type_review ON node.nid = content_type_review.nid 
LEFT JOIN vocabulary ON vocabulary.name = \"Review Types\"
LEFT JOIN term_node ON term_node.nid = node.nid
LEFT JOIN term_data ON (term_node.tid = term_data.tid AND term_data.vid = vocabulary.vid)
WHERE node.type='review' AND node.status=1 ORDER BY node.created DESC";

	if ($upload_flag) //if upload module is enabled also put number of file attachments
		$query = "SELECT ideas_stats.*, COUNT(upload.fid) AS FILE_COUNT FROM ( ". $query . " ) AS ideas_stats LEFT JOIN upload ON ideas_stats.nid = upload.nid GROUP BY ideas_stats.nid";
		
	if ($image_flag) //if image module is enabled also put number of images inserted
		$query = "SELECT idea_stats2.*, COUNT(image_attach.iid) AS IMAGE_COUNT FROM ( ". $query . " ) AS idea_stats2 LEFT JOIN image_attach ON idea_stats2.nid = image_attach.nid GROUP BY idea_stats2.nid";
		
	if ($gallery_flag) //if image module is enabled also put number of images inserted
		$query = "SELECT idea_stats3.*, COUNT(gallery_assist_item.pid) AS GALLERY_COuNT FROM ( ". $query . " ) AS idea_stats3 LEFT JOIN gallery_assist_item ON idea_stats3.nid = gallery_assist_item.nid GROUP BY idea_stats3.nid";		
		
	
	$relationships = db_query($query);

	//format_date($checkbox_values['#custom_date'], 'small')
	$page_html .= 'Review ID,Creation Date,Review title,Creator User ID, Creator User name,Review Value,Review Type,Reviewed Idea ID'.($upload_flag ? ",Attachment Count" :"").($image_flag ? ",Image Count" :"").($gallery_flag ? ",Gallery Count" :"")."\n";
	while ($data = db_fetch_object($relationships))
		$page_html .= $data->nid.",".format_date($data->created, 'small').",".$data->title.",".$data->USER_ID.",".$data->USER_NAME.",".$data->REVIEW_RATING.",".$data->REVIEW_TYPE.",".$data->IDEA_NID.($upload_flag ? ",".$data->FILE_COUNT : "").($image_flag ? ",".$data->IMAGE_COUNT : "").($gallery_flag ? ",".$data->GALLERY_COuNT : "")."\n";
		
	return $page_html;
}


/*****************************************************************************
 *********************** Idea Relationships Full Panel ***********************
 *****************************************************************************/
 
function idea_analytics_relationships_csv_export() {
	$page_html = "";
	
	$header = array(
		//drupal_render($form['list']['checkbox_all_ids']),
		theme('table_select_header_cell'),
		array('data' => t('Idea A'), 'field' => 'idea1'), //'sort' => 'asc'
		array('data' => t('Relationship'), 'field' => 'relationship_type'),
		array('data' => t('Idea B'), 'field' => 'idea2'),
		array('data' => t('Status'), 'field' => 'status'),
		array('data' => t('Date'), 'field' => 'date', 'sort' => 'desc'),
	);
	/*
	$relationships = pager_query("SELECT similar_ideas_relations.id, similar_ideas_relations.idea1, similar_ideas_relations.idea2, similar_ideas_relations.relationship_type, similar_ideas_relations.date, similar_ideas_relations.status, node.title AS idea1_title, node2.title AS idea2_title FROM similar_ideas_relations JOIN node ON similar_ideas_relations.idea1 = node.nid JOIN node AS node2 ON node2.nid = similar_ideas_relations.idea2 WHERE relationship_type <> 'NONE'".tablesort_sql($header),$rows_per_page); */
	
	$relationships = db_query("SELECT similar_ideas_relations.id, similar_ideas_relations.idea1, similar_ideas_relations.idea2, similar_ideas_relations.relationship_type, similar_ideas_relations.date, similar_ideas_relations.status, node.title AS idea1_title, node2.title AS idea2_title FROM similar_ideas_relations similar_ideas_relations JOIN node ON similar_ideas_relations.idea1 = node.nid JOIN node AS node2 ON node2.nid = similar_ideas_relations.idea2 WHERE similar_ideas_relations.relationship_type <> 'NONE' AND similar_ideas_relations.status<>'checked' AND similar_ideas_relations.status<>'denied' ORDER BY similar_ideas_relations.date");

	$page_html .= 'Idea A title,Idea A ID,Relationship,Idea B Title,Idea B ID,Status,Date'."\n";
	while ($data = db_fetch_object($relationships))
		$page_html .= $data->idea1_title.",".$data->idea1.",".$data->relationship_type.",".$data->idea2_title.",".$data->idea2.",".$data->status.",".$data->date."\n";
		
	return $page_html;
}

/*****************************************************************************
 ***************************** Idea Clustering Stats *************************
 *****************************************************************************/
 
function idea_analytics_cluster_analysis_csv_export() {
	$page_html = "";
	
	if (isset($_SESSION['cluster_analysis'])) //check if the clustering data was saved in the session otherwise don't write anything into CSV
	{
		$cluster_analysis = $_SESSION['cluster_analysis'];
		foreach ($cluster_analysis['overall_stats'] as $stat_name => $stat_value)
			$page_html .= "$stat_name, $stat_value"."\n";
		
		foreach ($_SESSION['cluster_analysis']['cluster_data'] as $cluster_info)
		{
			$page_html .= "\n";
			$page_html .= $cluster_info['name']."\n";
			$page_html .= 'Idea Count:'.$cluster_info['idea_count']."\n";
			$page_html .= 'Comment Count:'.$cluster_info['comment_count']."\n";
			$page_html .= 'Comment per Idea:'.$cluster_info['comment_per_idea']."\n";
			$page_html .= "TERMS"."\n";
			foreach ($cluster_info['term'] as $term_name => $term_idea_count)
				$page_html .= $term_name.",".$term_idea_count."\n";
			
			$page_html .= "WORKFLOW"."\n";	
			foreach ($cluster_info['workflow'] as $state_title => $state_idea_count)
				$page_html .= $state_title.",".$state_idea_count."\n";
		}
	}
	return $page_html;
}

?>