<?php

/**
 * This function creates the form to update RDF namespaces
 */
function idea_analytics_relationship_management($form_state, $page_number = 0) {

  //get all available relationship types
  $path = drupal_get_path('module', 'similar_ideas');
  require_once $path . '/similar_ideas.module';
  $fields = get_relation_fields();
  $relationship_types = array();
  foreach ($fields as $field) {
 	$name = substr($field, 15);
	$relationship_types[$name] = t(check_plain(ucfirst($name)));
  }

  $form['add'] = array(
    '#type' => 'fieldset',
    '#title' => t('Add relationship'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#tree' => FALSE,
/*    '#description' => t('RDFme allows to import external !vocabularies that are used as hints on !mapping and on the exported RDF files. The SPARQL Endpoint by default is !sparql, but you can find more at !list. Some SPARQL Endpoints use local data, in order to import a custom ontology you must perform a query at the endpoint to store the data in cache.',
      array(
        '!vocabularies' => l(t('vocabulary'), 'http://www.w3.org/standards/semanticweb/ontology'),
        '!mapping' => l(t('"RDF mapping" admin page'), 'admin/settings/rdfme/mapping'),
        '!sparql' => l('http://demo.openlinksw.com/sparql/', 'http://demo.openlinksw.com/sparql/'),
        '!list' => l('http://esw.w3.org/SparqlEndpoints', 'http://esw.w3.org/SparqlEndpoints'),
      )
    ), */
  );
  $form['add']['add_idea1_title'] = array(
    '#type' => 'textfield',
    '#size' => 40,
    '#maxlength' => 100,
    '#autocomplete_path' => 'idea/autocomplete',
  );
  $form['add']['add_relationship_type_name'] = array(
    '#type' => 'select',
    '#options' => $relationship_types,
//    '#size' => 10,
//    '#maxlength' => 50,
  );
  $form['add']['add_idea2_title'] = array(
    '#type' => 'textfield',
    '#size' => 40,
    '#maxlength' => 100,
    '#autocomplete_path' => 'idea/autocomplete',
  );
  $form['add']['add_relationship'] = array(
    '#type' => 'submit',
    '#value' => 'Add relationship',
  );
  $form['list'] = array(
    '#type' => 'fieldset',
    '#title' => t('Relationships'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#tree' => FALSE,
    '#description' => t('A full list of relationships.')
  );
  $form['page_number'] = array(
  	'#type' => 'value', 
  	'#value' => $page_number
  );
  
  $form['csv_export'] = array(

      '#value' => '<a href="?q=analytics_export/relationships_list/csv" style="float: right;"><img title="CSV Export" src="'.drupal_get_path('module', 'ideastream_analytics') .'/img/csv_icon.png"/></a>',

  );
  
  $rows_per_page = 10;
  $header = array(
  	//drupal_render($form['list']['checkbox_all_ids']),
  	theme('table_select_header_cell'),
  	array('data' => t('Idea A'), 'field' => 'idea1'), //'sort' => 'asc'
  	array('data' => t('Relationship'), 'field' => 'relationship_type'),
  	array('data' => t('Idea B'), 'field' => 'idea2'),
  	array('data' => t('Status'), 'field' => 'status'),
  	array('data' => t('Date'), 'field' => 'date', 'sort' => 'desc'),
  );
  /*
  $relationships = pager_query("SELECT similar_ideas_relations.id, similar_ideas_relations.idea1, similar_ideas_relations.idea2, similar_ideas_relations.relationship_type, similar_ideas_relations.date, similar_ideas_relations.status, node.title AS idea1_title, node2.title AS idea2_title FROM similar_ideas_relations JOIN node ON similar_ideas_relations.idea1 = node.nid JOIN node AS node2 ON node2.nid = similar_ideas_relations.idea2 WHERE relationship_type <> 'NONE'".tablesort_sql($header),$rows_per_page); */

  $relationships = pager_query("SELECT similar_ideas_relations.id, similar_ideas_relations.idea1, similar_ideas_relations.idea2, similar_ideas_relations.relationship_type, similar_ideas_relations.date, similar_ideas_relations.status, node.title AS idea1_title, node2.title AS idea2_title FROM similar_ideas_relations similar_ideas_relations JOIN node ON similar_ideas_relations.idea1 = node.nid JOIN node AS node2 ON node2.nid = similar_ideas_relations.idea2 WHERE similar_ideas_relations.relationship_type <> 'NONE' AND similar_ideas_relations.status<>'checked' AND similar_ideas_relations.status<>'denied'".tablesort_sql($header),$rows_per_page);
  
    while ($item = db_fetch_object($relationships)) {
    	$form['list']['checkbox_id_'.$item->id] = array(
    		'#type' => 'checkbox', 
//    		'#title' => t('Send me a copy.'),
    		'#return_value' => 1, 
    		'#default_value' => 0,  
    		'#custom_entry_id' => $item->id,
    		'#custom_idea1_id' => $item->idea1,
    		'#custom_idea1_title' => $item->idea1_title,
      		'#custom_relationship_type' => $item->relationship_type,
    		'#custom_idea2_id' => $item->idea2,
    		'#custom_idea2_title' => $item->idea2_title,
      		'#custom_status' => $item->status,
      		'#custom_date' => $item->date,
    		);
    }
  
  return $form;
}

function theme_idea_analytics_relationship_management($form) {
  
  $rows_per_page = 10;
  
  $rows = array();
  $rows[] = array(drupal_render($form['add']['add_idea1_title']), drupal_render($form['add']['add_relationship_type_name']), drupal_render($form['add']['add_idea2_title']));
  $header = array(t('Idea A'), t('Relationship'), t('Idea B'));
  $form['add']['#value'] = theme('table', $header, $rows) . drupal_render($form['add']['add_relationship']);
  unset($form['add']['add_idea1_title']);
  unset($form['add']['add_relationship_type_name']);
  unset($form['add']['add_idea2_title']);
  unset($form['add']['add_relationship']);
  
  $page_number = $form['page_number']['#value'];
  
  /*
  $form['list']['checkbox_all_ids'] = array(
    '#type' => 'checkbox',
  ); */
  
  $header = array(
  	//drupal_render($form['list']['checkbox_all_ids']),
  	theme('table_select_header_cell'),
  	array('data' => t('Idea A'), 'field' => 'idea1'), //'sort' => 'asc'
  	array('data' => t('Relationship'), 'field' => 'relationship_type'),
  	array('data' => t('Idea B'), 'field' => 'idea2'),
  	array('data' => t('Status'), 'field' => 'status'),
  	array('data' => t('Date'), 'field' => 'date', 'sort' => 'desc'),
  );

  $rows = array();

  foreach ($form['list'] as $checkbox_name => $checkbox_values) {
  	if (strstr($checkbox_name, 'checkbox_id_')) { //process only for checkboxes
	  	//prepare title string (trim if needed)
	  	$title1 = $checkbox_values['#custom_idea1_title'];
	  	if (strlen($title1) > 24) $title1 = substr_replace($title1,'...',24);
	  	$title2 = $checkbox_values['#custom_idea2_title'];
	  	if (strlen($title2) > 24) $title2 = substr_replace($title2,'…',24);
	  	
	  	//format relationship status (with colors and attach link to toggle state)
	  	$state = "<span style='color:gray; '>".$checkbox_values['#custom_status']."</span>";    
	  	if ($checkbox_values['#custom_status'] == 'approved') $state = "<span style='color:green; '>".$checkbox_values['#custom_status']."</span>";
	  	if ($checkbox_values['#custom_status'] == 'pending') $state = "<span style='color:orange; '>".$checkbox_values['#custom_status']."</span>";
	  	
	    $rows[] = array(
	      drupal_render($form['list']['checkbox_id_'.$checkbox_values['#custom_entry_id']]),
	      l($title1, 'node/' . $checkbox_values['#custom_idea1_id']),
	      $checkbox_values['#custom_relationship_type'],
	      l($title2, 'node/' . $checkbox_values['#custom_idea2_id']),
	      $state,
	      format_date($checkbox_values['#custom_date'], 'small'),
	    );
	    unset($form['list']['checkbox_id_'.$checkbox_values['#custom_entry_id']]);
    }
  }
  
  //prepare pager
  $pager_html = "";
  //check how many relationships in total and render pager if more than 1 page
  $relationship_count = db_query("SELECT COUNT(id) AS count_rel FROM similar_ideas_history WHERE relationship_type <> 'NONE' AND status <> 'checked' AND status <> 'denied'");
  if ($item = db_fetch_object($relationship_count)) {
  	$relationship_count = $item->count_rel;
  	if ($relationship_count > $rows_per_page)
  	{
  		$page_count = intval(($relationship_count -1 )/ $rows_per_page); //without the first which has a number 0
  		//if ($relationship_count % $rows_per_page>0) $page_count++;
		if ($page_number>=0 && $page_number<=$page_count) {
	  		$first_page_number = $page_number - 4;
	  		$last_page_number = $page_number + 4;
	  		
	  		if ($first_page_number <0) 
	  		{
	  			$last_page_number = $last_page_number - $first_page_number;
	  			$first_page_number = 0;
	  		}
	  		
	  		if ($last_page_number>$page_count)
	  		{
	  			$last_page_diff = $last_page_number - $page_count;
	  			$last_page_number = $page_count;
	  			$first_page_number = $first_page_number - $last_page_diff;
	  			if ($first_page_number<0) $first_page_number = 0;
	  		} 
	  		$previous_page_number = $page_number!=0 ? $page_number - 1 : -1;
	  		$next_page_number = $page_number!=$page_count ? $page_number+1 : -1;
	  		
	  		//generate pager html
	  		$pager_html = '<div class="item-list"><ul class="pager">';
	  		if ($previous_page_number!=-1) {
		  		$pager_html .= '<li class="pager-first first"><a href="'.url('analytics/relationship_management').'" title="Go to first page" class="active">« first</a></li>';
		  		$pager_html .= '<li class="pager-previous"><a href="'.url('analytics/relationship_management/'.$previous_page_number).'" title="Go to previous page" class="active">‹ previous</a></li>';
	  		}
	  		for ($i = $first_page_number; $i <= $last_page_number; $i++)
	  		{
	  		 $page_gui_number = $i +1;
	  		 if ($i == $page_number) //current page
	  		 	$pager_html .= '<li class="pager-current">'.$page_gui_number.'</li>';
	  		 else
	  		 	$pager_html .= '<li class="pager-item"><a href="'.url('analytics/relationship_management/'.$i).'" title="Go to page '.$page_gui_number.'" class="active">'.$page_gui_number.'</a></li>';
	  		}
	  		if ($next_page_number!=-1) {
		  		$pager_html .= '<li class="pager-next"><a href="'.url('analytics/relationship_management/'.$next_page_number).'" title="Go to next page" class="active">next ›</a></li>';
		  		$pager_html .= '<li class="pager-last last"><a href="'.url('analytics/relationship_management/'.$page_count).'" title="Go to last page" class="active">last »</a></li>';
	  		}
	  		$pager_html .= '</ul></div>';
  		}
  	}
  }
  
  $form['list']['delete_relationship'] = array(
    '#type' => 'submit',
    '#value' => 'Delete relationship',
  );
  
  $form['list']['appprove_relationship'] = array(
    '#type' => 'submit',
    '#value' => 'Approve relationship',
  );
  
  $form['list']['#value'] = theme('table', $header, $rows) . theme('pager');//. $pager_html;
  return drupal_render($form);
}

function idea_analytics_relationship_management_submit($form, &$form_state) {
	if ($form_state["clicked_button"]["#post"]["op"] == "Add relationship") {
		//drupal_set_message("Form_state: ".$result);
		if ($form_state['values']['add_idea1_title']!="" && $form_state['values']['add_idea2_title']!="")
			idea_analytics_add_relationship($form_state['values']['add_idea1_title'], $form_state['values']['add_idea2_title'], $form_state['values']['add_relationship_type_name']);	
	}
	if ($form_state["clicked_button"]["#post"]["op"] == "Approve relationship") {
	  foreach ($form_state['values'] as $key => $value) {
	  	if (strstr($key, 'checkbox_id_')) { //process only for checkboxes
			if ($value == 1) //if checkbox was checked
	  			//drupal_set_message("Delete operation for checkbox with id: ".$form['list'][$key]['#custom_entry_id']);
	  			idea_analytics_approve_relationship($form['list'][$key]['#custom_idea1_id'],$form['list'][$key]['#custom_idea2_id'],$form['list'][$key]['#custom_relationship_type']);
	  	}
	  }
	}
	if ($form_state["clicked_button"]["#post"]["op"] == "Delete relationship") {
	  foreach ($form_state['values'] as $key => $value) {
	  	if (strstr($key, 'checkbox_id_')) { //process only for checkboxes
			if ($value == 1) //if checkbox was checked
	  			//drupal_set_message("Delete operation for checkbox with id: ".$form['list'][$key]['#custom_entry_id']);
	  			idea_analytics_delete_relationship($form['list'][$key]['#custom_idea1_id'],$form['list'][$key]['#custom_idea2_id'],$form['list'][$key]['#custom_relationship_type']);
	  	}
	  }
	}
/*
  if ($form_state['values']['uri'] != '' &&  $form_state['values']['prefix'] != '') {
    rdfme_import_vocabulary($form_state['values']['uri'], $form_state['values']['prefix'], $form_state['values']['sparql_endpoint']);
  }
  else {
    drupal_set_message(t('Namespace and URI cannot be blank fields'));
  }
  // Redirect to the rdfme module settings
  $form_state['redirect'] = 'admin/settings/rdfme/namespaces';
  */

//  var_dump($form_state);
//	$form_state['values']["checkbox_id_10"];
//  drupal_set_message("Invoked: ".$form_state["clicked_button"]["#post"]["op"]);
//  drupal_set_message($result);
}

//form operations

//Function to delete one relationship (by clicking the red cross)
function idea_analytics_delete_relationship($node_id1, $node_id2, $relationship_type) {
	
	$nid = $node_id1;	
	$node = node_load($nid, NULL, TRUE);
//	var_dump($node);

	if ($node && $node->type=="idea") {			
			$actualrels = viewnoderel($node);
			$destiny_idea = $node_id2;
			$node2 = node_load($destiny_idea);
			if ($actualrels[$destiny_idea]){
				global $user;	
				$status = "approved";
				$idea1 = max($nid,$node2->nid);
				$idea2= min($nid,$node2->nid);
				$author = getAuthor($idea1,$idea2);
				$reviewer = $user->name;
				$date = time();
				$relation = "NONE";

				//Removing from actual node.
				$field = $node->$actualrels[$destiny_idea];				
				$key = array_search(array('nid' => $destiny_idea), $field);
				unset($field[$key]);
				$node->$actualrels[$destiny_idea] = $field;
			
				//Removing from destiny node.
				//Checking if current relation have inverse relation
				$q_inverse2 = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='".$actualrels[$destiny_idea]."'");
				$result2 = db_fetch_array($q_inverse2);  	
				$inverse2 = $result2['inverse'];
				if($inverse2 !='none' && $result2){
					$inverse2 = TRUE;
					$inverse_rel2 = $result2['inverse'];
				}else $inverse2 = FALSE;
				
				if ($inverse2){	
					$field = $node2->$actualrels[$destiny_idea];		
					$key = array_search(array('nid' => $nid), $field);
					unset($field[$key]);
					$node2->$actualrels[$destiny_idea] = $field;
				}
				
				node_save($node);
				node_save($node2);
				
				$result1 = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$nid.",".$destiny_idea.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')"); //log operation in relationships history table
				$result2 = db_query("DELETE FROM similar_ideas_relations WHERE idea1=".$nid." AND idea2=".$destiny_idea. " AND relationship_type='".$relationship_type."'"); //remove relationship
				drupal_set_message("Relationship deleted properly");
				
			}else {
				//check if relationship exists in the similar_ideas table (possible for pending relationships)
				$result2 = db_query("SELECT * FROM similar_ideas_relations WHERE idea1=".$nid." AND idea2=".$destiny_idea." AND status='pending'");
				$value2 = db_fetch_array($result2);
				if ($value2) {
					if($value2['status'] =='pending'){ //if pending switch to denied (if denied do nothing)
						global $user;
						//update history table
						$result_history = db_query("SELECT * FROM similar_ideas_history WHERE idea1=".$nid." AND idea2=".$destiny_idea." AND relationship_type='".$relationship_type."'");
						$value_history = db_fetch_array($result_history);
						if ($value_history) {
							$result1 = db_query("INSERT INTO similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$nid.",".$destiny_idea.",'".$value2['relationship_type']."','".$value2['author']."',".time().",'denied','".$user->name."')");
							$update = db_query("UPDATE similar_ideas_history SET status='checked', reviewer='".$user->name."' WHERE id=".$value_history['id']);
						}
						//$update1 = db_query("UPDATE similar_ideas_relations SET idea1=".$nid.", idea2=".$destiny_idea.", date=".time().", status='denied', reviewer='".$user->name."', author='".$value2['author']."', relationship_type='".$value2['relationship_type']."' WHERE id=".$value2['id']);
						$result2 = db_query("DELETE FROM similar_ideas_relations WHERE idea1=".$nid." AND idea2=".$destiny_idea. " AND relationship_type='".$relationship_type."'"); //remove relationship
					}
				} else
				drupal_set_message("Idea Relation not found. Please use a correct one","error");				
			}
			
			
	} else {
		drupal_set_message("Idea ID not found. Please use a correct one","error");		
	}
	$content .= "Saved";
	//drupal_goto("node/".$nid."/similar_ideas");
	return $content;
}

//Function to approve one relationship
function idea_analytics_approve_relationship($node_id1, $node_id2, $relationship_type) {
		$result = null;
		//$result = db_query("SELECT * FROM similar_ideas_relations WHERE id=".$rel_id);
		$result = db_query("SELECT * FROM similar_ideas_history WHERE idea1=".$node_id1." AND idea2=".$node_id2. " AND relationship_type='".$relationship_type."' AND status='pending'");
		$value = db_fetch_array($result);  	
		if ($value['status'] == 'pending'){
			global $user;	
			$date = time();
			$reviewer = $user->name;
			$idea1 = $value['idea1'];
			$idea2 = $value['idea2'];
			$relation = $value['relationship_type'];
			$author = $value['author'];
			$status = "approved";
			$rel_id = $value['id'];
					
			//DELETE POSSIBLE FIELDS
			$node = node_load($idea1);
			$rels1 = viewnoderel($node);
			$node2 = node_load($idea2);
			$rels2 = viewnoderel($node2);
			
			$this_relation = $rels1[$node2->nid];
			
			//Boolean to know if we are going to add relationship in both ideas or just in the current one.
			$q_symetric = db_query("SELECT symetric FROM similar_ideas_relationtypes WHERE name='".$this_relation."'");
			$result = db_fetch_array($q_symetric);  	
			$symetric = $result['symetric'];
			if($symetric == 1) $symetric = TRUE;
			else $symetric = FALSE;
			
			if (array_key_exists($node2->nid , $rels1) || array_key_exists($node->nid , $rels2)){
					
					//$this_relation = $rels1[$node2->nid];
					//Removing from node1.							
					$field = $node->$this_relation;				
					$key = array_search(array('nid' => $node2->nid), $field);
					unset($field[$key]);
					$node->$this_relation = $field;	
					
					//Removing from node2.	
					if($symetric){	
						$field = $node2->$this_relation;		
						$key = array_search(array('nid' => $node->nid), $field);
						unset($field[$key]);
						$node2->$this_relation = $field;
					}
			}
		
			//INSERT FIELDS
			if ($relation != 'NONE'){
				$relationship = "field_relation_".$relation;
				
				$field = $node->$relationship;
				$field[]=array('nid' => $node2->nid);			
				$node->$relationship = $field;
			
				if($symetric){
					$field = $node2->$relationship;
					$field[]=array('nid' => $node->nid);	
					$node2->$relationship = $field;		
				}
				
			}
			node_save($node);
			node_save($node2);
			$result1 = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
			$update = db_query("UPDATE similar_ideas_history SET status='checked', reviewer='".$reviewer."' WHERE id=".$rel_id);
			
			if($symetric){
				$result_dest = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea2.",".$idea1.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
				$select = db_query("SELECT * FROM similar_ideas_history WHERE idea1=".$idea2." AND idea2=".$idea1." AND status='pending'");
				$s2 = db_fetch_array($select);
				if ($s2) $update_dest = db_query("UPDATE similar_ideas_history SET status='checked', reviewer='".$reviewer."' WHERE id=".$s2['id']);	
			}
			
			//Checking for current_rels ideas
			$result2 = db_query("SELECT id FROM similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
			$value2 = db_fetch_array($result2);
			if ($value2) {
				if($relation !='NONE'){
					$update1 = db_query("UPDATE similar_ideas_relations SET idea1=".$idea1.", idea2=".$idea2.", date=".$date.", status='".$status."', reviewer='".$reviewer."', author='".$author."', relationship_type='".$relation."' WHERE id=".$value2['id']);
				}else{
					$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
				}
			}else{
				$insert2 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."','".$status."',".$date.",'".$reviewer."')");
			}
			
			if ($symetric){
				$result2 = db_query("SELECT id FROM similar_ideas_relations WHERE idea1=".$idea2." AND idea2=".$idea1);
				$value2 = db_fetch_array($result2);
				if ($value2) {
					if($relation !='NONE'){
						$update1 = db_query("UPDATE similar_ideas_relations SET idea1=".$idea2.", idea2=".$idea1.", date=".$date.", status='".$status."', reviewer='".$reviewer."', author='".$author."', relationship_type='".$relation."' WHERE id=".$value2['id']);
					}else{
						$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea2." AND idea2=".$idea1);
					}
				}else{
					if ($status == "approved")  $insert2 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$idea2.",".$idea1.",'".$relation."','".$author."','".$status."',".$date.",'".$reviewer."')");
				}
			}
		}
		else{
			drupal_set_message("[$node_id1 , $relationship_type, $node_id2] is not a pending relationship!");	
		}
	$content .="Moderation Saved";
	return $content;
}

//Function to add one relationship
function idea_analytics_add_relationship($node1_title, $node2_title, $relationship_type) {

	//adding idea selected by title (if manually typed idea repeats on the suggestions list than its ignored)
	if ($node1_title!='' && $node2_title!=''  && $relationship_type!='')
	{
		$related1_nid = strrpos($node1_title, "[nid:");
		if ($related1_nid == false) //if the nid was not added by auto detection check in the database
		{
			$result = db_query("SELECT nid FROM node WHERE node.type='idea' AND LOWER(title) LIKE LOWER('%s')",$node1_title);
			if ($data = db_fetch_object($result))
				$related1_nid = $data->nid;
		} else { //if idea was selected using autocomplete extract the auto completed node nid
			$related1_nid = substr($node1_title, $related1_nid+5);
			$related1_nid = substr($related1_nid, 0, strlen($related1_nid)-1);
		}
		
		$related2_nid = strrpos($node2_title, "[nid:");
		if ($related2_nid == false) //if the nid was not added by auto detection check in the database
		{
			$result = db_query("SELECT nid FROM node WHERE node.type='idea' AND LOWER(title) LIKE LOWER('%s')",$node2_title);
			if ($data = db_fetch_object($result))
				$related2_nid = $data->nid;
		} else { //if idea was selected using autocomplete extract the auto completed node nid
			$related2_nid = substr($node2_title, $related2_nid+5);
			$related2_nid = substr($related2_nid, 0, strlen($related2_nid)-1);
		}

		if ($related1_nid!=false && $related2_nid!=false) 
		{
			//before adding relationship check if it doesn't already exist
			$result = db_query("SELECT nid FROM content_field_relation_".$relationship_type." WHERE nid = %s AND field_relation_".$relationship_type."_nid = %s",$related1_nid, $related2_nid);
			$data = db_fetch_object($result);
			if ($data==NULL)
			{
				$node = node_load($related1_nid);
				$relationship = "field_relation_".$relationship_type;
				$destiny_idea = $related2_nid;
				
				//Boolean to know if we are going to add relationship in both ideas or just in the current one.
				$q_inverse = db_query("SELECT inverse FROM similar_ideas_relationtypes WHERE name='".$relationship."'");
				$result = db_fetch_array($q_inverse);  	
				$inverse = $result['inverse'];
				if($inverse !='none' && $result){
					$inverse = TRUE;
					$inverse_rel = $result['inverse'];
				}else $inverse = FALSE;

				
				$node2 = node_load($destiny_idea);	
				
				
				$permission = user_access('post relationships without approval', NULL, FALSE);
		
				if ($relationship){ // 0 = --Set Relationship-- So nothing to store…		
					global $user;			
					$status = "pending";			
					$author = $user->name;
					$reviewer = "NONE";
					$date = time();
					$relation = substr($relationship, 15);
					
					if ($permission){//Storing the new relationships in  the fields (No approval required)
						$field = $node->$relationship;
						$field[]=array('nid' => $destiny_idea);			
						$node->$relationship = $field;
						
						if($inverse){
							$field = $node2->$relationship;
							$field[]=array('nid' => $related1_nid);	
							$node2->$relationship = $field;
						}
						
						$status = "approved";
						$reviewer = $user->name;
						//store relationships in drupal tables						
						node_save($node2);
						node_save($node);
					}					
					/*
					 *Checking former pending ideas.
					 */
					$idea1 = $related1_nid;
					$idea2 = $node2->nid;
					//Updating status if relation exists…
					$result = db_query("SELECT id FROM similar_ideas_history WHERE status='pending' AND (idea1=".$idea1." AND idea2=".$idea2.")");
					$value = db_fetch_array($result);  		
					if ($value['id']) $update = db_query("UPDATE similar_ideas_history SET status='auto-checked', reviewer='".$author."' WHERE id=".$value['id']);
					
					//Inserting new data inside history table
					$result1 = db_query("INSERT INTO  similar_ideas_history (idea1,idea2,relationship_type,author,date,status,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."',".$date.",'".$status."','".$reviewer."')");
					
					
					/*
					 *Checking for current_rels ideas
					 */
					if($permission){
						$result2 = db_query("SELECT id FROM similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
						$value2 = db_fetch_array($result2);
						if ($value2) {
							if($relation !='NONE'){
								$update1 = db_query("UPDATE similar_ideas_relations SET idea1=".$idea1.", idea2=".$idea2.", date=".$date.", status='".$status."', reviewer='".$reviewer."', author='".$author."', relationship_type='".$relation."' WHERE id=".$value2['id']);
							}else{
								$result2 = db_query("DELETE FROM  similar_ideas_relations WHERE idea1=".$idea1." AND idea2=".$idea2);
							}
						}else{
							if($relation !='NONE') $insert2 = db_query("INSERT INTO  similar_ideas_relations (idea1,idea2,relationship_type,author,status,date,reviewer) VALUES (".$idea1.",".$idea2.",'".$relation."','".$author."','".$status."',".$date.",'".$reviewer."')");
						}
					}
					
					drupal_set_message('Relationship added.');
				}
			
		    } //else drupal_set_message('Similar idea selected by title already has a relationship.');
      	}
    }

}


?>