
//input data mockup 
var clustered_data = [
/*  {"centroids":
    [
    	[-0.0030517985627636, -0.29966203137265],
    	[-0.38167648954098, 0.07934693825106],
		[0.54864149316357, 0.50966892479011],
		[-0.32093721707996, 0.40910954933475]
    ]
  }, */
  [ 
    [-0.14772465919567,-0.14010596567641],
    [-0.23776591292466,-0.24526282920653],
    [-0.13580257942135,-0.22297588532241],
    [0.067743012474463,-0.55194165079139],
    [0.43829114625339,-0.33802382586649]
  ],
  [
    [-0.45634957656525,0.15639762076332],
	[-0.30700340251672,0.0022962557388029]
  ],
  [
    [0.54864149316357,0.50966892479011]
  ],
  [
    [-0.32093721707996,0.40910954933475]
  ]
];

var clustered_data_postprocessed = [
    [-0.14772465919567,-0.14010596567641,'cluster1'],
    [-0.23776591292466,-0.24526282920653,'cluster1'],
    [-0.13580257942135,-0.22297588532241,'cluster1'],
    [0.067743012474463,-0.55194165079139,'cluster1'],
    [0.43829114625339,-0.33802382586649,'cluster1'],
    [-0.45634957656525,0.15639762076332,'cluster2'],
	[-0.30700340251672,0.0022962557388029,'cluster2'],
    [0.54864149316357,0.50966892479011,'cluster3'],
    [-0.32093721707996,0.40910954933475,'cluster4']
];
//var cluster_data;


/*****************  READ DRUPAL VARIABLES ******************/

//window.setTimeout("get_sources()",200);
console.log("analytics_cluster_plot: JS loaded");
var cluster_data; //information used for cluster visualisation (generated server side by drupal)
var cluster_settings; //advanced settings for clustering

//kick off d3 after window has finished loading
window.onload = function get_sources() {

//load settings from Drupal
cluster_settings = Drupal.settings.ideastream_analytics.advanced_settings;
if (cluster_settings!=null) {
		console.log("analytics_cluster_plot: variables lodaded - cluster settings");
		setupFormListner(cluster_settings);
	}

//load clustering data
cluster_data = Drupal.settings.ideastream_analytics.cluster_data;
if (cluster_data!=null) {
	console.log("analytics_cluster_plot: variables lodaded - cluster data");
	renderClusters(cluster_data);
	}
//d3.select('html').append('div').text('test');

/*
	module_path = Drupal.settings.location.module_path;
	ideas_source = Drupal.settings.current_sources.ideas_source;
	talents_source = Drupal.settings.current_sources.talents_source;
	get_file_path();
	try_load_xml_ideas_file(ideas_source); */
}

/*****************  CLUSTERS VISUALISATION PROCESSING ******************/

function renderClusters(cluster_data) {
	var total_width = 614; //960;
	var total_height = 500;

	var margin = {top: 20, right: 20, bottom: 30, left: 40},
	    width = total_width - margin.left - margin.right,
	    height = total_height - margin.top - margin.bottom;
	
	var x = d3.scale.linear()
	    .range([0, width]);
	
	var y = d3.scale.linear()
	    .range([height, 0]);
	
	var color = d3.scale.category10();
	
	var xAxis = d3.svg.axis()
	    .scale(x)
	    .orient("bottom");
	
	var yAxis = d3.svg.axis()
	    .scale(y)
	    .orient("left");
	
	var svg = d3.select("body #ideaanalytics_cluster_plot").append("svg")
	    .attr("width", width + margin.left + margin.right)
	    .attr("height", height + margin.top + margin.bottom)
	  .append("g")
	    .attr("transform", "translate(" + margin.left + "," + margin.top + ")");

    //console.log('test!!!');
    /*
d3.select('#ideaanalytics_cluster_plot').selectAll('div') //for every element of the main array
  .data([[1,2], [2,3], [3,4]])
  .enter()
  .append('div')
  .text("Part1")
  
  .selectAll('div') //for every subarray element make a nested div
  .data(function(d) { return d })
  .enter()
  .append('div')
  .text(function(d) { return d }); */
  //.text(String);
    
    /*
    svg.append("circle")
    .attr("cx", 50)
    .attr("cy", 50)
    .attr("r", 50); */
    
/*
d3.tsv("data.tsv", function(error, data) {
  data.forEach(function(d) {
    d.sepalLength = +d.sepalLength;
    d.sepalWidth = +d.sepalWidth;
  }); */
  
	var matrix = [
	  [11975,  5871], [8916, 2868],
	  [ 1951, 10048], [2060, 6171],
	  [ 8010, 16145], [8090, 8045],
	  [ 1013,   990],  [940, 6907]
	];

  x.domain(d3.extent(cluster_data, function(d) { return d[0]; })).nice();
  y.domain(d3.extent(cluster_data, function(d) { return d[1]; })).nice();

/*
	// X and Y axis ON /OFF
  svg.append("g")
      .attr("class", "x axis")
      .attr("transform", "translate(0," + height + ")")
      .call(xAxis)
    .append("text")
      .attr("class", "label")
      .attr("x", width)
      .attr("y", -6)
      .style("text-anchor", "end")
      .text("Sepal Width (cm)");

  svg.append("g")
      .attr("class", "y axis")
      .call(yAxis)
    .append("text")
      .attr("class", "label")
      .attr("transform", "rotate(-90)")
      .attr("y", 6)
      .attr("dy", ".71em")
      .style("text-anchor", "end")
      .text("Sepal Length (cm)"); */

  var circles = svg.selectAll(".dot")
      .data(cluster_data)
    .enter().append("circle")
      .attr("class", function(d) { if (d[2][0]!='idea') return "dot term_dot"; else return "dot"; })
      .attr("r", 3.5)
      .attr("cx", function(d) { return x(d[0]); })
      .attr("cy", function(d) { return y(d[1]); })
      .style("fill", function(d) { return color(d[3]); });
      
  //add tooltips for dots that represent terms
  
  // what to do when we mouse over a bubble
	var mouseOn = function() { 
		var circle = d3.select(this);

	// transition to increase size/opacity of bubble
		circle.transition()
		.duration(800).style("opacity", 1)
		.attr("r", 8).ease("elastic");

	// function to move mouseover item to front of SVG stage, in case
	// another bubble overlaps it
		d3.selection.prototype.moveToFront = function() { 
		  return this.each(function() { 
			this.parentNode.appendChild(this); 
		  }); 
		};

	// skip this functionality for IE9, which doesn't like it
		if (!$.browser.msie) {
			circle.moveToFront();	
			}
	};
	// what happens when we leave a bubble?
	var mouseOff = function() {
		var circle = d3.select(this);

		// go back to original size and opacity
		circle.transition()
		.duration(800)
		.attr("r", 3.5).ease("elastic"); //.style("opacity", .5)

	}; 
  
  // run the mouseon/out functions
  svg.selectAll(".term_dot").on("mouseover", mouseOn);
  svg.selectAll(".term_dot").on("mouseout", mouseOff);
  
  //using tipsy library to display tooltips when mouse on/off

  svg.selectAll(".term_dot").append("title")
			.text(function(d) { return d[2][2]; });

  $(".term_dot").tipsy({ gravity: 's', });

/*
  $(".dot").qtip({
         style: {
		    content: {
		        text: 'I look very similar to a ClueTip tooltip in terms of my callout pointer.'
		    },
            classes: 'qtip-dark',
            tip: {
                corner: true
            }
        },
        position: {
            my: 'top center',  // Position my top left...
            at: 'bottom center', // at the bottom right of...
        }

         // Your config here
     }); */

  var legend = svg.selectAll(".legend")
      .data(color.domain())
    .enter().append("g")
      .attr("class", "legend")
      .attr("transform", function(d, i) { return "translate(0," + i * 20 + ")"; });

  legend.append("rect")
      .attr("x", width - 18)
      .attr("width", 18)
      .attr("height", 18)
      .style("fill", color);

  legend.append("text")
      .attr("x", width - 24)
      .attr("y", 9)
      .attr("dy", ".35em")
      .style("text-anchor", "end")
      .text(function(d) { return d; /* "test";*/ });

 /* }); */
}

/************** CLUSTERING SETTINGS - DYNAMIC FORM FILLING *************/

function setupFormListner(cluster_settings) {
	console.log('analytics_cluster_plot: setting up listner');
	$('select[name="chart_cluster_criteria"]').change(function() {  			
  			cluster_count = cluster_settings[$('option:selected', this).text()].cluster_count;
  			if (cluster_count instanceof Array) cluster_count = cluster_count[cluster_count.length-1]; //drupal_add_js sometimes adds many values without deleteing previous ones, if array is detected take the last values which is the most recent one
  			
  			max_terms = cluster_settings[$('option:selected', this).text()].max_terms;
  			if (max_terms instanceof Array) max_terms = max_terms[max_terms.length-1];
  			
  			blacklist = cluster_settings[$('option:selected', this).text()].blacklist;
  			if (blacklist instanceof Array) blacklist = blacklist[blacklist.length-1];
  			
  			$('input[name="advanced_settings[cluster_count]"]').val(cluster_count);
  			$('input[name="advanced_settings[term_list_length]"]').val(max_terms);
  			$('input[name="advanced_settings[term_blacklist]"]').val(blacklist);
		});
}

/*****************  CLUSTERS OVERVIEW HTML PROCESSING ******************/

//add more/less button to show/hide exessive amount of terms from the cluster theme description
$(document).ready(function(){
  $(".analytics_details_toggle_link").click(function(){
    $(this).parent().find(".analytics_details_toggle_content").toggle();
    if ($(this).text() == 'more') $(this).text("less");
    else 
    	$(this).text("more");
    event.preventDefault();
  });
  
  
  //$(".dot").append('<title>testest</title>');
//  $(".dot").append("zupa");
  /*
  $("circle").qtip({
         style: {
		    content: {
		        text: 'I look very similar to a ClueTip tooltip in terms of my callout pointer.'
		    },
            classes: 'qtip-dark',
            tip: {
                corner: true
            }
        },
        position: {
            my: 'top center',  // Position my top left...
            at: 'bottom center', // at the bottom right of...
        }

         // Your config here
     }); */
});